From 4fea418abd003adfa3005f5996a5a5434daf6532 Mon Sep 17 00:00:00 2001
From: enen92 <92enen@gmail.com>
Date: Sat, 25 Jun 2022 16:17:09 +0100
Subject: [PATCH 1/9] Unwrap dll

---
 xbmc/CMakeLists.txt                           |   1 -
 xbmc/DllPaths.h                               |   4 +-
 xbmc/DllPaths_generated.h.in                  |   3 -
 xbmc/DllPaths_generated_android.h.in          |   3 -
 xbmc/DllPaths_win32.h                         |  12 -
 .../DVDInputStreams/CMakeLists.txt            |   1 -
 .../DVDInputStreamNavigator.cpp               | 207 +++--
 .../DVDInputStreams/DVDInputStreamNavigator.h |   5 +-
 .../VideoPlayer/DVDInputStreams/DllDvdNav.h   | 275 ------
 17 files changed, 106 insertions(+), 3189 deletions(-)
 delete mode 100644 xbmc/DllPaths_win32.h
 delete mode 100644 xbmc/cores/VideoPlayer/DVDInputStreams/DllDvdNav.h

diff --git a/xbmc/CMakeLists.txt b/xbmc/CMakeLists.txt
index b7c838b3da..73af63b731 100644
--- a/xbmc/CMakeLists.txt
+++ b/xbmc/CMakeLists.txt
@@ -42,7 +42,6 @@ set(HEADERS AutoSwitch.h
             DatabaseManager.h
             DbUrl.h
             DllPaths.h
-            DllPaths_win32.h
             DynamicDll.h
             FileItem.h
             FileItemListModification.h
diff --git a/xbmc/DllPaths.h b/xbmc/DllPaths.h
index 09bdd1ba3d..33fb46635e 100644
--- a/xbmc/DllPaths.h
+++ b/xbmc/DllPaths.h
@@ -8,9 +8,7 @@
 
 #pragma once
 
-#ifdef TARGET_WINDOWS
-#include "DllPaths_win32.h"
-#elif defined (TARGET_ANDROID)
+#if defined (TARGET_ANDROID)
 #include "DllPaths_generated_android.h"
 #else
 #include "DllPaths_generated.h"
diff --git a/xbmc/DllPaths_generated.h.in b/xbmc/DllPaths_generated.h.in
index f29faa41fd..405a7b5b29 100644
--- a/xbmc/DllPaths_generated.h.in
+++ b/xbmc/DllPaths_generated.h.in
@@ -11,9 +11,6 @@
 /* prefix install location */
 #define PREFIX_USR_PATH        "@prefix@"
 
-/* VideoPlayer */
-#define DLL_PATH_LIBDVDNAV     "special://xbmcbin/system/players/VideoPlayer/libdvdnav-@ARCH@.so"
-
 /* sse4 */
 #define DLL_PATH_LIBSSE4      "special://xbmcbin/system/libsse4-@ARCH@.so"
 
diff --git a/xbmc/DllPaths_generated_android.h.in b/xbmc/DllPaths_generated_android.h.in
index d15988e361..70ceb669aa 100644
--- a/xbmc/DllPaths_generated_android.h.in
+++ b/xbmc/DllPaths_generated_android.h.in
@@ -17,8 +17,5 @@
 //   We only keep @ARCH@ here to retain the same structure as *nix.
 // * foo.so will be renamed libfoo.so in the packaging stage
 
-/* VideoPlayer */
-#define DLL_PATH_LIBDVDNAV     "libdvdnav-@ARCH@.so"
-
 /* Android's libui for gralloc */
 #define DLL_PATH_LIBUI         "libui.so"
diff --git a/xbmc/DllPaths_win32.h b/xbmc/DllPaths_win32.h
deleted file mode 100644
index ea41058a54..0000000000
--- a/xbmc/DllPaths_win32.h
+++ /dev/null
@@ -1,12 +0,0 @@
-/*
- *  Copyright (C) 2005-2018 Team Kodi
- *  This file is part of Kodi - https://kodi.tv
- *
- *  SPDX-License-Identifier: GPL-2.0-or-later
- *  See LICENSES/README.md for more information.
- */
-
-#pragma once
-
-/* VideoPlayer */
-#define DLL_PATH_LIBDVDNAV     "special://xbmcbin/libdvdnav.dll"
diff --git a/xbmc/cores/VideoPlayer/DVDInputStreams/CMakeLists.txt b/xbmc/cores/VideoPlayer/DVDInputStreams/CMakeLists.txt
index 576ddda150..1aecf6f032 100644
--- a/xbmc/cores/VideoPlayer/DVDInputStreams/CMakeLists.txt
+++ b/xbmc/cores/VideoPlayer/DVDInputStreams/CMakeLists.txt
@@ -22,7 +22,6 @@ set(HEADERS BlurayStateSerializer.h
             DVDInputStreamNavigator.h
             DVDInputStreamStack.h
             DVDStateSerializer.h
-            DllDvdNav.h
             InputStreamAddon.h
             InputStreamMultiStreams.h
             InputStreamMultiSource.h
diff --git a/xbmc/cores/VideoPlayer/DVDInputStreams/DVDInputStreamNavigator.cpp b/xbmc/cores/VideoPlayer/DVDInputStreams/DVDInputStreamNavigator.cpp
index 178ed401dc..75f00b0051 100644
--- a/xbmc/cores/VideoPlayer/DVDInputStreams/DVDInputStreamNavigator.cpp
+++ b/xbmc/cores/VideoPlayer/DVDInputStreams/DVDInputStreamNavigator.cpp
@@ -115,9 +115,6 @@ bool CDVDInputStreamNavigator::Open()
   CEnvironment::putenv("DVDCSS_CACHE=" + CSpecialProtocol::TranslatePath("special://masterprofile/cache"));
 #endif
 
-  // load libdvdnav.dll
-  if (!m_dll.Load())
-    return false;
 
   // load the dvd language codes
   // g_LangCodeExpander.LoadStandardCodes();
@@ -153,10 +150,10 @@ bool CDVDInputStreamNavigator::Open()
     m_pstream = std::make_unique<CDVDInputStreamFile>(
         m_item, XFILE::READ_TRUNCATED | XFILE::READ_BITRATE | XFILE::READ_CHUNKED);
 #if DVDNAV_VERSION >= 60100
-    if (!m_pstream->Open() || m_dll.dvdnav_open_stream2(&m_dvdnav, m_pstream.get(), &loggerCallback,
+    if (!m_pstream->Open() || dvdnav_open_stream2(&m_dvdnav, m_pstream.get(), &loggerCallback,
                                                         &m_dvdnav_stream_cb) != DVDNAV_STATUS_OK)
 #else
-    if (!m_pstream->Open() || m_dll.dvdnav_open_stream(&m_dvdnav, m_pstream.get(), &m_dvdnav_stream_cb) != DVDNAV_STATUS_OK)
+    if (!m_pstream->Open() || dvdnav_open_stream(&m_dvdnav, m_pstream.get(), &m_dvdnav_stream_cb) != DVDNAV_STATUS_OK)
 #endif
     {
       CLog::Log(LOGERROR, "Error opening image file or Error on dvdnav_open_stream");
@@ -165,10 +162,10 @@ bool CDVDInputStreamNavigator::Open()
     }
   }
 #if DVDNAV_VERSION >= 60100
-  else if (m_dll.dvdnav_open2(&m_dvdnav, nullptr, &loggerCallback, path.c_str()) !=
+  else if (dvdnav_open2(&m_dvdnav, nullptr, &loggerCallback, path.c_str()) !=
            DVDNAV_STATUS_OK)
 #else
-  else if (m_dll.dvdnav_open(&m_dvdnav, path.c_str()) != DVDNAV_STATUS_OK)
+  else if (dvdnav_open(&m_dvdnav, path.c_str()) != DVDNAV_STATUS_OK)
 #endif
   {
     CLog::Log(LOGERROR, "Error on dvdnav_open");
@@ -183,16 +180,16 @@ bool CDVDInputStreamNavigator::Open()
   else
   {
     // find out what region dvd reports itself to be from, and use that as mask if available
-    if (m_dll.dvdnav_get_disk_region_mask(m_dvdnav, &mask) == DVDNAV_STATUS_ERR)
+    if (dvdnav_get_disk_region_mask(m_dvdnav, &mask) == DVDNAV_STATUS_ERR)
     {
       CLog::LogF(LOGERROR, "Error getting DVD region code: {}",
-                 m_dll.dvdnav_err_to_string(m_dvdnav));
+                 dvdnav_err_to_string(m_dvdnav));
       mask = 0xff;
     }
   }
 
   CLog::Log(LOGDEBUG, "{} - Setting region mask {:02x}", __FUNCTION__, mask);
-  m_dll.dvdnav_set_region_mask(m_dvdnav, mask);
+  dvdnav_set_region_mask(m_dvdnav, mask);
 
   // get default language settings
   char language_menu[3];
@@ -213,48 +210,48 @@ bool CDVDInputStreamNavigator::Open()
   if (language_subtitle[0] == '\0') strcpy(language_subtitle, "en");
 
   // set default language settings
-  if (m_dll.dvdnav_menu_language_select(m_dvdnav, (char*)language_menu) != DVDNAV_STATUS_OK)
+  if (dvdnav_menu_language_select(m_dvdnav, (char*)language_menu) != DVDNAV_STATUS_OK)
   {
     CLog::Log(LOGERROR, "Error on setting default menu language: {}",
-              m_dll.dvdnav_err_to_string(m_dvdnav));
+              dvdnav_err_to_string(m_dvdnav));
     CLog::Log(LOGERROR, "Defaulting to \"en\"");
     //! @bug libdvdnav isn't const correct
-    m_dll.dvdnav_menu_language_select(m_dvdnav, const_cast<char*>("en"));
+    dvdnav_menu_language_select(m_dvdnav, const_cast<char*>("en"));
   }
 
-  if (m_dll.dvdnav_audio_language_select(m_dvdnav, (char*)language_audio) != DVDNAV_STATUS_OK)
+  if (dvdnav_audio_language_select(m_dvdnav, (char*)language_audio) != DVDNAV_STATUS_OK)
   {
     CLog::Log(LOGERROR, "Error on setting default audio language: {}",
-              m_dll.dvdnav_err_to_string(m_dvdnav));
+              dvdnav_err_to_string(m_dvdnav));
     CLog::Log(LOGERROR, "Defaulting to \"en\"");
     //! @bug libdvdnav isn't const correct
-    m_dll.dvdnav_audio_language_select(m_dvdnav, const_cast<char*>("en"));
+    dvdnav_audio_language_select(m_dvdnav, const_cast<char*>("en"));
   }
 
-  if (m_dll.dvdnav_spu_language_select(m_dvdnav, (char*)language_subtitle) != DVDNAV_STATUS_OK)
+  if (dvdnav_spu_language_select(m_dvdnav, (char*)language_subtitle) != DVDNAV_STATUS_OK)
   {
     CLog::Log(LOGERROR, "Error on setting default subtitle language: {}",
-              m_dll.dvdnav_err_to_string(m_dvdnav));
+              dvdnav_err_to_string(m_dvdnav));
     CLog::Log(LOGERROR, "Defaulting to \"en\"");
     //! @bug libdvdnav isn't const correct
-    m_dll.dvdnav_spu_language_select(m_dvdnav, const_cast<char*>("en"));
+    dvdnav_spu_language_select(m_dvdnav, const_cast<char*>("en"));
   }
 
   // set read ahead cache usage
-  if (m_dll.dvdnav_set_readahead_flag(m_dvdnav, 1) != DVDNAV_STATUS_OK)
+  if (dvdnav_set_readahead_flag(m_dvdnav, 1) != DVDNAV_STATUS_OK)
   {
     CLog::Log(LOGERROR, "Error on dvdnav_set_readahead_flag: {}",
-              m_dll.dvdnav_err_to_string(m_dvdnav));
+              dvdnav_err_to_string(m_dvdnav));
     Close();
     return false;
   }
 
   // set the PGC positioning flag to have position information relatively to the
   // whole feature instead of just relatively to the current chapter
-  if (m_dll.dvdnav_set_PGC_positioning_flag(m_dvdnav, 1) != DVDNAV_STATUS_OK)
+  if (dvdnav_set_PGC_positioning_flag(m_dvdnav, 1) != DVDNAV_STATUS_OK)
   {
     CLog::Log(LOGERROR, "Error on dvdnav_set_PGC_positioning_flag: {}",
-              m_dll.dvdnav_err_to_string(m_dvdnav));
+              dvdnav_err_to_string(m_dvdnav));
     Close();
     return false;
   }
@@ -267,18 +264,18 @@ bool CDVDInputStreamNavigator::Open()
     uint8_t* buf_ptr = buf;
 
     // must startup vm and pgc
-    m_dll.dvdnav_get_next_cache_block(m_dvdnav,&buf_ptr,&event,&len);
-    m_dll.dvdnav_sector_search(m_dvdnav, 0, SEEK_SET);
+    dvdnav_get_next_cache_block(m_dvdnav,&buf_ptr,&event,&len);
+    dvdnav_sector_search(m_dvdnav, 0, SEEK_SET);
 
     // first try title menu
-    if(m_dll.dvdnav_menu_call(m_dvdnav, DVD_MENU_Title) != DVDNAV_STATUS_OK)
+    if(dvdnav_menu_call(m_dvdnav, DVD_MENU_Title) != DVDNAV_STATUS_OK)
     {
       CLog::Log(LOGERROR, "Error on dvdnav_menu_call(Title): {}",
-                m_dll.dvdnav_err_to_string(m_dvdnav));
+                dvdnav_err_to_string(m_dvdnav));
       // next try root menu
-      if(m_dll.dvdnav_menu_call(m_dvdnav, DVD_MENU_Root) != DVDNAV_STATUS_OK )
+      if(dvdnav_menu_call(m_dvdnav, DVD_MENU_Root) != DVDNAV_STATUS_OK )
         CLog::Log(LOGERROR, "Error on dvdnav_menu_call(Root): {}",
-                  m_dll.dvdnav_err_to_string(m_dvdnav));
+                  dvdnav_err_to_string(m_dvdnav));
     }
   }
 
@@ -302,9 +299,9 @@ void CDVDInputStreamNavigator::Close()
   if (!m_dvdnav) return;
 
   // finish off by closing the dvdnav device
-  if (m_dll.dvdnav_close(m_dvdnav) != DVDNAV_STATUS_OK)
+  if (dvdnav_close(m_dvdnav) != DVDNAV_STATUS_OK)
   {
-    CLog::Log(LOGERROR, "Error on dvdnav_close: {}", m_dll.dvdnav_err_to_string(m_dvdnav));
+    CLog::Log(LOGERROR, "Error on dvdnav_close: {}", dvdnav_err_to_string(m_dvdnav));
     return ;
   }
 
@@ -390,11 +387,11 @@ int CDVDInputStreamNavigator::ProcessBlock(uint8_t* dest_buffer, int* read)
     result = DVDNAV_STATUS_OK;
   }
   else
-    result = m_dll.dvdnav_get_next_cache_block(m_dvdnav, &buf, &m_lastevent, &len);
+    result = dvdnav_get_next_cache_block(m_dvdnav, &buf, &m_lastevent, &len);
 
   if (result == DVDNAV_STATUS_ERR)
   {
-    CLog::Log(LOGERROR, "Error getting next block: {}", m_dll.dvdnav_err_to_string(m_dvdnav));
+    CLog::Log(LOGERROR, "Error getting next block: {}", dvdnav_err_to_string(m_dvdnav));
     m_bEOF = true;
     return NAVRESULT_ERROR;
   }
@@ -495,7 +492,7 @@ int CDVDInputStreamNavigator::ProcessBlock(uint8_t* dest_buffer, int* read)
         }
         else
         {
-          bool menu = (0 == m_dll.dvdnav_is_domain_vts(m_dvdnav));
+          bool menu = (0 == dvdnav_is_domain_vts(m_dvdnav));
           if (menu != m_bInMenu)
           {
             m_bInMenu = menu;
@@ -515,13 +512,13 @@ int CDVDInputStreamNavigator::ProcessBlock(uint8_t* dest_buffer, int* read)
         uint32_t pos = 0;
         uint32_t len = 0;
 
-        m_dll.dvdnav_current_title_info(m_dvdnav, &m_iTitle, &m_iPart);
-        m_dll.dvdnav_get_number_of_titles(m_dvdnav, &m_iTitleCount);
+        dvdnav_current_title_info(m_dvdnav, &m_iTitle, &m_iPart);
+        dvdnav_get_number_of_titles(m_dvdnav, &m_iTitleCount);
         if(m_iTitle > 0)
-          m_dll.dvdnav_get_number_of_parts(m_dvdnav, m_iTitle, &m_iPartCount);
+          dvdnav_get_number_of_parts(m_dvdnav, m_iTitle, &m_iPartCount);
         else
           m_iPartCount = 0;
-        m_dll.dvdnav_get_position(m_dvdnav, &pos, &len);
+        dvdnav_get_position(m_dvdnav, &pos, &len);
 
         // get chapters' timestamps if we have not cached them yet
         if (m_mapTitleChapters.find(m_iTitle) == m_mapTitleChapters.end())
@@ -529,7 +526,7 @@ int CDVDInputStreamNavigator::ProcessBlock(uint8_t* dest_buffer, int* read)
           uint64_t* times = NULL;
           uint64_t duration;
           //dvdnav_describe_title_chapters returns 0 on failure and NULL for times
-          int entries = m_dll.dvdnav_describe_title_chapters(m_dvdnav, m_iTitle, &times, &duration);
+          int entries = dvdnav_describe_title_chapters(m_dvdnav, m_iTitle, &times, &duration);
 
           if (entries != m_iPartCount)
             CLog::Log(LOGDEBUG,
@@ -577,11 +574,11 @@ int CDVDInputStreamNavigator::ProcessBlock(uint8_t* dest_buffer, int* read)
 
         // Calculate current time
         //unsigned int pos, len;
-        //m_dll.dvdnav_get_position(m_dvdnav, &pos, &len);
+        //dvdnav_get_position(m_dvdnav, &pos, &len);
         //m_iTime = (int)(((int64_t)m_iTotalTime * pos) / len);
 
-        pci_t* pci = m_dll.dvdnav_get_current_nav_pci(m_dvdnav);
-        m_dll.dvdnav_get_current_nav_dsi(m_dvdnav);
+        pci_t* pci = dvdnav_get_current_nav_pci(m_dvdnav);
+        dvdnav_get_current_nav_dsi(m_dvdnav);
 
         if(!pci)
         {
@@ -590,7 +587,7 @@ int CDVDInputStreamNavigator::ProcessBlock(uint8_t* dest_buffer, int* read)
         }
 
         /* if we have any buttons or are not in vts domain we assume we are in menu */
-        bool menu = pci->hli.hl_gi.hli_ss || (0 == m_dll.dvdnav_is_domain_vts(m_dvdnav));
+        bool menu = pci->hli.hl_gi.hli_ss || (0 == dvdnav_is_domain_vts(m_dvdnav));
         if (menu != m_bInMenu)
         {
           m_bInMenu = menu;
@@ -618,7 +615,7 @@ int CDVDInputStreamNavigator::ProcessBlock(uint8_t* dest_buffer, int* read)
         m_iVobUnitStart = pci->pci_gi.vobu_s_ptm;
         m_iVobUnitStop = pci->pci_gi.vobu_e_ptm;
 
-        m_iTime = (int) ( m_dll.dvdnav_get_current_time(m_dvdnav)  / 90 );
+        m_iTime = (int) ( dvdnav_get_current_time(m_dvdnav)  / 90 );
 
         iNavresult = m_pVideoPlayer->OnDiscNavResult((void*)pci, DVDNAV_NAV_PACKET);
       }
@@ -657,7 +654,7 @@ int CDVDInputStreamNavigator::ProcessBlock(uint8_t* dest_buffer, int* read)
     // probably not needed since function will check if buf
     // is part of the internal cache, but do it for good measure
     if( buf != m_lastblock )
-      m_dll.dvdnav_free_cache_block(m_dvdnav, buf);
+      dvdnav_free_cache_block(m_dvdnav, buf);
 
   return iNavresult;
 }
@@ -669,11 +666,11 @@ bool CDVDInputStreamNavigator::SetActiveAudioStream(int iId)
   if (!m_dvdnav)
     return false;
 
-  dvdnav_status_t ret = m_dll.dvdnav_set_active_stream(m_dvdnav, iId, DVD_AUDIO_STREAM);
+  dvdnav_status_t ret = dvdnav_set_active_stream(m_dvdnav, iId, DVD_AUDIO_STREAM);
   if (ret == DVDNAV_STATUS_ERR)
   {
     CLog::LogF(LOGERROR, "dvdnav_set_active_stream (audio) failed: {}",
-               m_dll.dvdnav_err_to_string(m_dvdnav));
+               dvdnav_err_to_string(m_dvdnav));
   }
 
   return ret == DVDNAV_STATUS_OK;
@@ -686,11 +683,11 @@ bool CDVDInputStreamNavigator::SetActiveSubtitleStream(int iId)
   if (!m_dvdnav)
     return false;
 
-  dvdnav_status_t ret = m_dll.dvdnav_set_active_stream(m_dvdnav, iId, DVD_SUBTITLE_STREAM);
+  dvdnav_status_t ret = dvdnav_set_active_stream(m_dvdnav, iId, DVD_SUBTITLE_STREAM);
   if (ret == DVDNAV_STATUS_ERR)
   {
     CLog::LogF(LOGERROR, "dvdnav_set_active_stream (subtitles) failed: {}",
-               m_dll.dvdnav_err_to_string(m_dvdnav));
+               dvdnav_err_to_string(m_dvdnav));
   }
 
   return ret == DVDNAV_STATUS_OK;
@@ -700,14 +697,14 @@ void CDVDInputStreamNavigator::ActivateButton()
 {
   if (m_dvdnav)
   {
-    m_dll.dvdnav_button_activate(m_dvdnav, m_dll.dvdnav_get_current_nav_pci(m_dvdnav));
+    dvdnav_button_activate(m_dvdnav, dvdnav_get_current_nav_pci(m_dvdnav));
   }
 }
 
 void CDVDInputStreamNavigator::SelectButton(int iButton)
 {
   if (!m_dvdnav) return;
-  m_dll.dvdnav_button_select(m_dvdnav, m_dll.dvdnav_get_current_nav_pci(m_dvdnav), iButton);
+  dvdnav_button_select(m_dvdnav, dvdnav_get_current_nav_pci(m_dvdnav), iButton);
 }
 
 int CDVDInputStreamNavigator::GetCurrentButton()
@@ -718,10 +715,10 @@ int CDVDInputStreamNavigator::GetCurrentButton()
   }
 
   int button = 0;
-  if (m_dll.dvdnav_get_current_highlight(m_dvdnav, &button) == DVDNAV_STATUS_ERR)
+  if (dvdnav_get_current_highlight(m_dvdnav, &button) == DVDNAV_STATUS_ERR)
   {
     CLog::LogF(LOGERROR, "dvdnav_get_current_highlight failed: {}",
-               m_dll.dvdnav_err_to_string(m_dvdnav));
+               dvdnav_err_to_string(m_dvdnav));
     return -1;
   }
   return button;
@@ -732,7 +729,7 @@ void CDVDInputStreamNavigator::CheckButtons()
   if (m_dvdnav && m_bCheckButtons)
   {
     m_bCheckButtons = false;
-    pci_t* pci = m_dll.dvdnav_get_current_nav_pci(m_dvdnav);
+    pci_t* pci = dvdnav_get_current_nav_pci(m_dvdnav);
     int iCurrentButton = GetCurrentButton();
 
     if( iCurrentButton > 0 && iCurrentButton < 37 )
@@ -758,7 +755,7 @@ void CDVDInputStreamNavigator::CheckButtons()
       {
         CLog::Log(LOGWARNING, "CDVDInputStreamNavigator: found invalid button({})", iCurrentButton);
         CLog::Log(LOGWARNING, "CDVDInputStreamNavigator: switching to button({}) instead", i + 1);
-        m_dll.dvdnav_button_select(m_dvdnav, pci, i + 1);
+        dvdnav_button_select(m_dvdnav, pci, i + 1);
         break;
       }
     }
@@ -769,7 +766,7 @@ int CDVDInputStreamNavigator::GetTotalButtons()
 {
   if (!m_dvdnav) return 0;
 
-  pci_t* pci = m_dll.dvdnav_get_current_nav_pci(m_dvdnav);
+  pci_t* pci = dvdnav_get_current_nav_pci(m_dvdnav);
 
   int counter = 0;
   for (const btni_t& buttonInfo : pci->hli.btnit)
@@ -787,30 +784,30 @@ int CDVDInputStreamNavigator::GetTotalButtons()
 
 void CDVDInputStreamNavigator::OnUp()
 {
-  if (m_dvdnav) m_dll.dvdnav_upper_button_select(m_dvdnav, m_dll.dvdnav_get_current_nav_pci(m_dvdnav));
+  if (m_dvdnav) dvdnav_upper_button_select(m_dvdnav, dvdnav_get_current_nav_pci(m_dvdnav));
 }
 
 void CDVDInputStreamNavigator::OnDown()
 {
-  if (m_dvdnav) m_dll.dvdnav_lower_button_select(m_dvdnav, m_dll.dvdnav_get_current_nav_pci(m_dvdnav));
+  if (m_dvdnav) dvdnav_lower_button_select(m_dvdnav, dvdnav_get_current_nav_pci(m_dvdnav));
 }
 
 void CDVDInputStreamNavigator::OnLeft()
 {
-  if (m_dvdnav) m_dll.dvdnav_left_button_select(m_dvdnav, m_dll.dvdnav_get_current_nav_pci(m_dvdnav));
+  if (m_dvdnav) dvdnav_left_button_select(m_dvdnav, dvdnav_get_current_nav_pci(m_dvdnav));
 }
 
 void CDVDInputStreamNavigator::OnRight()
 {
-  if (m_dvdnav) m_dll.dvdnav_right_button_select(m_dvdnav, m_dll.dvdnav_get_current_nav_pci(m_dvdnav));
+  if (m_dvdnav) dvdnav_right_button_select(m_dvdnav, dvdnav_get_current_nav_pci(m_dvdnav));
 }
 
 bool CDVDInputStreamNavigator::OnMouseMove(const CPoint &point)
 {
   if (m_dvdnav)
   {
-    pci_t* pci = m_dll.dvdnav_get_current_nav_pci(m_dvdnav);
-    return (DVDNAV_STATUS_OK == m_dll.dvdnav_mouse_select(m_dvdnav, pci, (int32_t)point.x, (int32_t)point.y));
+    pci_t* pci = dvdnav_get_current_nav_pci(m_dvdnav);
+    return (DVDNAV_STATUS_OK == dvdnav_mouse_select(m_dvdnav, pci, (int32_t)point.x, (int32_t)point.y));
   }
   return false;
 }
@@ -819,8 +816,8 @@ bool CDVDInputStreamNavigator::OnMouseClick(const CPoint &point)
 {
   if (m_dvdnav)
   {
-    pci_t* pci = m_dll.dvdnav_get_current_nav_pci(m_dvdnav);
-    return (DVDNAV_STATUS_OK == m_dll.dvdnav_mouse_activate(m_dvdnav, pci, (int32_t)point.x, (int32_t)point.y));
+    pci_t* pci = dvdnav_get_current_nav_pci(m_dvdnav);
+    return (DVDNAV_STATUS_OK == dvdnav_mouse_activate(m_dvdnav, pci, (int32_t)point.x, (int32_t)point.y));
   }
   return false;
 }
@@ -832,12 +829,12 @@ bool CDVDInputStreamNavigator::OnMenu()
     return false;
   }
 
-  return m_dll.dvdnav_menu_call(m_dvdnav, DVD_MENU_Escape) == DVDNAV_STATUS_OK;
+  return dvdnav_menu_call(m_dvdnav, DVD_MENU_Escape) == DVDNAV_STATUS_OK;
 }
 
 void CDVDInputStreamNavigator::OnBack()
 {
-  if (m_dvdnav) m_dll.dvdnav_go_up(m_dvdnav);
+  if (m_dvdnav) dvdnav_go_up(m_dvdnav);
 }
 
 // we don't allow skipping in menu's cause it will remove menu overlays
@@ -845,7 +842,7 @@ void CDVDInputStreamNavigator::OnNext()
 {
   if (m_dvdnav && !(IsInMenu() && GetTotalButtons() > 0))
   {
-    m_dll.dvdnav_next_pg_search(m_dvdnav);
+    dvdnav_next_pg_search(m_dvdnav);
   }
 }
 
@@ -854,7 +851,7 @@ void CDVDInputStreamNavigator::OnPrevious()
 {
   if (m_dvdnav && !(IsInMenu() && GetTotalButtons() > 0))
   {
-    m_dll.dvdnav_prev_pg_search(m_dvdnav);
+    dvdnav_prev_pg_search(m_dvdnav);
   }
 }
 
@@ -862,13 +859,13 @@ void CDVDInputStreamNavigator::SkipStill()
 {
   if (!m_dvdnav)
     return ;
-  m_dll.dvdnav_still_skip(m_dvdnav);
+  dvdnav_still_skip(m_dvdnav);
 }
 
 void CDVDInputStreamNavigator::SkipWait()
 {
   if (!m_dvdnav) return ;
-  m_dll.dvdnav_wait_skip(m_dvdnav);
+  dvdnav_wait_skip(m_dvdnav);
 }
 
 CDVDInputStream::ENextStream CDVDInputStreamNavigator::NextStream()
@@ -893,7 +890,7 @@ int CDVDInputStreamNavigator::GetActiveSubtitleStream()
     return activeStream;
   }
 
-  const int8_t logicalSubStreamId = m_dll.dvdnav_get_active_spu_stream(m_dvdnav);
+  const int8_t logicalSubStreamId = dvdnav_get_active_spu_stream(m_dvdnav);
   if (logicalSubStreamId < 0)
   {
     return activeStream;
@@ -902,7 +899,7 @@ int CDVDInputStreamNavigator::GetActiveSubtitleStream()
   int subStreamCount = GetSubTitleStreamCount();
   for (int subpN = 0; subpN < subStreamCount; subpN++)
   {
-    if (m_dll.dvdnav_get_spu_logical_stream(m_dvdnav, subpN) == logicalSubStreamId)
+    if (dvdnav_get_spu_logical_stream(m_dvdnav, subpN) == logicalSubStreamId)
     {
       activeStream = subpN;
       break;
@@ -920,7 +917,7 @@ SubtitleStreamInfo CDVDInputStreamNavigator::GetSubtitleStreamInfo(const int iId
 
   subp_attr_t subp_attributes;
 
-  if (m_dll.dvdnav_get_spu_attr(m_dvdnav, iId, &subp_attributes) == DVDNAV_STATUS_OK)
+  if (dvdnav_get_spu_attr(m_dvdnav, iId, &subp_attributes) == DVDNAV_STATUS_OK)
   {
     SetSubtitleStreamName(info, subp_attributes);
 
@@ -973,7 +970,7 @@ int CDVDInputStreamNavigator::GetSubTitleStreamCount()
   {
     return 0;
   }
-  return m_dll.dvdnav_get_number_of_streams(m_dvdnav, DVD_SUBTITLE_STREAM);
+  return dvdnav_get_number_of_streams(m_dvdnav, DVD_SUBTITLE_STREAM);
 }
 
 int CDVDInputStreamNavigator::GetActiveAudioStream()
@@ -983,7 +980,7 @@ int CDVDInputStreamNavigator::GetActiveAudioStream()
     return -1;
   }
 
-  const int8_t logicalAudioStreamId = m_dll.dvdnav_get_active_audio_stream(m_dvdnav);
+  const int8_t logicalAudioStreamId = dvdnav_get_active_audio_stream(m_dvdnav);
   if (logicalAudioStreamId < 0)
   {
     return -1;
@@ -993,7 +990,7 @@ int CDVDInputStreamNavigator::GetActiveAudioStream()
   int audioStreamCount = GetAudioStreamCount();
   for (int audioN = 0; audioN < audioStreamCount; audioN++)
   {
-    if (m_dll.dvdnav_get_audio_logical_stream(m_dvdnav, audioN) == logicalAudioStreamId)
+    if (dvdnav_get_audio_logical_stream(m_dvdnav, audioN) == logicalAudioStreamId)
     {
       activeStream = audioN;
       break;
@@ -1090,7 +1087,7 @@ AudioStreamInfo CDVDInputStreamNavigator::GetAudioStreamInfo(const int iId)
 
   audio_attr_t audio_attributes;
 
-  if (m_dll.dvdnav_get_audio_attr(m_dvdnav, iId, &audio_attributes) == DVDNAV_STATUS_OK)
+  if (dvdnav_get_audio_attr(m_dvdnav, iId, &audio_attributes) == DVDNAV_STATUS_OK)
   {
     SetAudioStreamName(info, audio_attributes);
 
@@ -1112,7 +1109,7 @@ int CDVDInputStreamNavigator::GetAudioStreamCount()
   {
     return 0;
   }
-  return m_dll.dvdnav_get_number_of_streams(m_dvdnav, DVD_AUDIO_STREAM);
+  return dvdnav_get_number_of_streams(m_dvdnav, DVD_AUDIO_STREAM);
 }
 
 int CDVDInputStreamNavigator::GetAngleCount()
@@ -1122,7 +1119,7 @@ int CDVDInputStreamNavigator::GetAngleCount()
 
   int number_of_angles;
   int current_angle;
-  dvdnav_status_t status = m_dll.dvdnav_get_angle_info(m_dvdnav, &current_angle, &number_of_angles);
+  dvdnav_status_t status = dvdnav_get_angle_info(m_dvdnav, &current_angle, &number_of_angles);
 
   if (status == DVDNAV_STATUS_OK)
     return number_of_angles;
@@ -1137,9 +1134,9 @@ int CDVDInputStreamNavigator::GetActiveAngle()
 
   int number_of_angles;
   int current_angle;
-  if (m_dll.dvdnav_get_angle_info(m_dvdnav, &current_angle, &number_of_angles) == DVDNAV_STATUS_ERR)
+  if (dvdnav_get_angle_info(m_dvdnav, &current_angle, &number_of_angles) == DVDNAV_STATUS_ERR)
   {
-    CLog::LogF(LOGERROR, "Failed to get current angle: {}", m_dll.dvdnav_err_to_string(m_dvdnav));
+    CLog::LogF(LOGERROR, "Failed to get current angle: {}", dvdnav_err_to_string(m_dvdnav));
     return -1;
   }
   return current_angle;
@@ -1150,7 +1147,7 @@ bool CDVDInputStreamNavigator::SetAngle(int angle)
   if (!m_dvdnav)
     return false;
 
-  dvdnav_status_t status = m_dll.dvdnav_angle_change(m_dvdnav, angle);
+  dvdnav_status_t status = dvdnav_angle_change(m_dvdnav, angle);
 
   return (status == DVDNAV_STATUS_OK);
 }
@@ -1173,8 +1170,8 @@ bool CDVDInputStreamNavigator::GetCurrentButtonInfo(CDVDOverlaySpu& pOverlayPict
     return false;
   }
 
-  if (DVDNAV_STATUS_OK == m_dll.dvdnav_get_highlight_area(
-                              m_dll.dvdnav_get_current_nav_pci(m_dvdnav), button, iButtonType, &hl))
+  if (DVDNAV_STATUS_OK == dvdnav_get_highlight_area(
+                              dvdnav_get_current_nav_pci(m_dvdnav), button, iButtonType, &hl))
   {
     // button cropping information
     pOverlayPicture.crop_i_x_start = hl.sx;
@@ -1222,10 +1219,10 @@ int CDVDInputStreamNavigator::GetTime()
 
 bool CDVDInputStreamNavigator::PosTime(int iTimeInMsec)
 {
-  if( m_dll.dvdnav_jump_to_sector_by_time(m_dvdnav, iTimeInMsec * 90, 0) == DVDNAV_STATUS_ERR )
+  if( dvdnav_jump_to_sector_by_time(m_dvdnav, iTimeInMsec * 90, 0) == DVDNAV_STATUS_ERR )
   {
     CLog::Log(LOGDEBUG, "dvdnav: dvdnav_jump_to_sector_by_time failed( {} )",
-              m_dll.dvdnav_err_to_string(m_dvdnav));
+              dvdnav_err_to_string(m_dvdnav));
     return false;
   }
   m_iTime = iTimeInMsec;
@@ -1252,26 +1249,26 @@ bool CDVDInputStreamNavigator::SeekChapter(int iChapter)
 
   if (iChapter == (m_iPart + 1))
   {
-    if (m_dll.dvdnav_next_pg_search(m_dvdnav) == DVDNAV_STATUS_ERR)
+    if (dvdnav_next_pg_search(m_dvdnav) == DVDNAV_STATUS_ERR)
     {
       CLog::Log(LOGERROR, "dvdnav: dvdnav_next_pg_search( {} )",
-                m_dll.dvdnav_err_to_string(m_dvdnav));
+                dvdnav_err_to_string(m_dvdnav));
       return false;
     }
   }
   else if (iChapter == (m_iPart - 1))
   {
-    if (m_dll.dvdnav_prev_pg_search(m_dvdnav) == DVDNAV_STATUS_ERR)
+    if (dvdnav_prev_pg_search(m_dvdnav) == DVDNAV_STATUS_ERR)
     {
       CLog::Log(LOGERROR, "dvdnav: dvdnav_prev_pg_search( {} )",
-                m_dll.dvdnav_err_to_string(m_dvdnav));
+                dvdnav_err_to_string(m_dvdnav));
       return false;
     }
   }
-  else if (m_dll.dvdnav_part_play(m_dvdnav, m_iTitle, iChapter) == DVDNAV_STATUS_ERR)
+  else if (dvdnav_part_play(m_dvdnav, m_iTitle, iChapter) == DVDNAV_STATUS_ERR)
   {
     CLog::Log(LOGERROR, "dvdnav: dvdnav_part_play failed( {} )",
-              m_dll.dvdnav_err_to_string(m_dvdnav));
+              dvdnav_err_to_string(m_dvdnav));
     return false;
   }
 
@@ -1283,8 +1280,8 @@ bool CDVDInputStreamNavigator::SeekChapter(int iChapter)
 
 float CDVDInputStreamNavigator::GetVideoAspectRatio()
 {
-  int iAspect = m_dll.dvdnav_get_video_aspect(m_dvdnav);
-  int iPerm = m_dll.dvdnav_get_video_scale_permission(m_dvdnav);
+  int iAspect = dvdnav_get_video_aspect(m_dvdnav);
+  int iPerm = dvdnav_get_video_scale_permission(m_dvdnav);
 
   //The video scale permissions should give if the source is letterboxed
   //and such. should be able to give us info that we can zoom in automatically
@@ -1307,7 +1304,7 @@ void CDVDInputStreamNavigator::EnableSubtitleStream(bool bEnable)
   if (!m_dvdnav)
     return;
 
-  m_dll.dvdnav_toggle_spu_stream(m_dvdnav, static_cast<uint8_t>(bEnable));
+  dvdnav_toggle_spu_stream(m_dvdnav, static_cast<uint8_t>(bEnable));
 }
 
 bool CDVDInputStreamNavigator::IsSubtitleStreamEnabled()
@@ -1315,7 +1312,7 @@ bool CDVDInputStreamNavigator::IsSubtitleStreamEnabled()
   if (!m_dvdnav)
     return false;
 
-  return m_dll.dvdnav_get_active_spu_stream(m_dvdnav) >= 0;
+  return dvdnav_get_active_spu_stream(m_dvdnav) >= 0;
 }
 
 bool CDVDInputStreamNavigator::FillDVDState(DVDState& dvdState)
@@ -1325,11 +1322,11 @@ bool CDVDInputStreamNavigator::FillDVDState(DVDState& dvdState)
     return false;
   }
 
-  if (m_dll.dvdnav_current_title_program(m_dvdnav, &dvdState.title, &dvdState.pgcn,
+  if (dvdnav_current_title_program(m_dvdnav, &dvdState.title, &dvdState.pgcn,
                                          &dvdState.pgn) == DVDNAV_STATUS_ERR)
   {
     CLog::LogF(LOGERROR, "Failed to get current title info ({})",
-               m_dll.dvdnav_err_to_string(m_dvdnav));
+               dvdnav_err_to_string(m_dvdnav));
     return false;
   }
 
@@ -1355,7 +1352,7 @@ bool CDVDInputStreamNavigator::GetState(std::string& xmlstate)
   }
 
   // do not save state if we are not playing a title stream (e.g. if we are in menus)
-  if (!m_dll.dvdnav_is_domain_vts(m_dvdnav))
+  if (!dvdnav_is_domain_vts(m_dvdnav))
   {
     return false;
   }
@@ -1389,8 +1386,8 @@ bool CDVDInputStreamNavigator::SetState(const std::string& xmlstate)
     return false;
   }
 
-  m_dll.dvdnav_program_play(m_dvdnav, dvdState.title, dvdState.pgcn, dvdState.pgn);
-  m_dll.dvdnav_angle_change(m_dvdnav, dvdState.current_angle);
+  dvdnav_program_play(m_dvdnav, dvdState.title, dvdState.pgcn, dvdState.pgn);
+  dvdnav_angle_change(m_dvdnav, dvdState.current_angle);
   SetActiveSubtitleStream(dvdState.subp_num);
   SetActiveAudioStream(dvdState.audio_num);
   EnableSubtitleStream(dvdState.sub_enabled);
@@ -1403,7 +1400,7 @@ std::string CDVDInputStreamNavigator::GetDVDTitleString()
     return "";
 
   const char* str = NULL;
-  if (m_dll.dvdnav_get_title_string(m_dvdnav, &str) == DVDNAV_STATUS_OK)
+  if (dvdnav_get_title_string(m_dvdnav, &str) == DVDNAV_STATUS_OK)
     return str;
   else
     return "";
@@ -1415,7 +1412,7 @@ std::string CDVDInputStreamNavigator::GetDVDSerialString()
     return "";
 
   const char* str = NULL;
-  if (m_dll.dvdnav_get_serial_string(m_dvdnav, &str) == DVDNAV_STATUS_OK)
+  if (dvdnav_get_serial_string(m_dvdnav, &str) == DVDNAV_STATUS_OK)
     return str;
   else
     return "";
@@ -1456,12 +1453,12 @@ void CDVDInputStreamNavigator::GetVideoResolution(uint32_t* width, uint32_t* hei
   if (!m_dvdnav) return;
 
   // for version <= 5.0.3 this functions returns 0 instead of DVDNAV_STATUS_OK and -1 instead of DVDNAV_STATUS_ERR
-  int status = m_dll.dvdnav_get_video_resolution(m_dvdnav, width, height);
+  int status = dvdnav_get_video_resolution(m_dvdnav, width, height);
   if (status == -1)
   {
     CLog::Log(LOGWARNING,
               "CDVDInputStreamNavigator::GetVideoResolution - Failed to get resolution ({})",
-              m_dll.dvdnav_err_to_string(m_dvdnav));
+              dvdnav_err_to_string(m_dvdnav));
     *width = 0;
     *height = 0;
   }
diff --git a/xbmc/cores/VideoPlayer/DVDInputStreams/DVDInputStreamNavigator.h b/xbmc/cores/VideoPlayer/DVDInputStreams/DVDInputStreamNavigator.h
index b0efa8e52d..e7e2d809ff 100644
--- a/xbmc/cores/VideoPlayer/DVDInputStreams/DVDInputStreamNavigator.h
+++ b/xbmc/cores/VideoPlayer/DVDInputStreams/DVDInputStreamNavigator.h
@@ -14,10 +14,12 @@
 #include "DVDInputStream.h"
 #include "DVDInputStreamFile.h"
 #include "DVDStateSerializer.h"
-#include "DllDvdNav.h"
 #include "cores/MenuType.h"
 #include "utils/Geometry.h"
 
+#include <dvdnav/dvdnav.h>
+#include <dvdnav/dvd_types.h>
+
 #include <string>
 
 #define DVD_VIDEO_BLOCKSIZE         DVD_VIDEO_LB_LEN // 2048 bytes
@@ -157,7 +159,6 @@ protected:
   */
   bool FillDVDState(DVDState& dvdstate);
 
-  DllDvdNav m_dll;
   bool m_bCheckButtons;
   bool m_bEOF;
 
diff --git a/xbmc/cores/VideoPlayer/DVDInputStreams/DllDvdNav.h b/xbmc/cores/VideoPlayer/DVDInputStreams/DllDvdNav.h
deleted file mode 100644
index 7a0c149e02..0000000000
--- a/xbmc/cores/VideoPlayer/DVDInputStreams/DllDvdNav.h
+++ /dev/null
@@ -1,275 +0,0 @@
-/*
- *  Copyright (C) 2005-2018 Team Kodi
- *  This file is part of Kodi - https://kodi.tv
- *
- *  SPDX-License-Identifier: GPL-2.0-or-later
- *  See LICENSES/README.md for more information.
- */
-
-#pragma once
-
-extern "C" {
-#define DVDNAV_COMPILE
- #include <stdint.h>
-
- #include "dvdnav/dvdnav.h"
-
- #ifndef WIN32
- #define WIN32
- #endif // WIN32
-
- #ifndef HAVE_CONFIG_H
- #define HAVE_CONFIG_H
- #endif
-
- #include "dvdnav/dvd_types.h"
-
- #ifdef WIN32 // WIN32INCLUDES
- #undef HAVE_CONFIG_H
- #endif
-}
-#include "DynamicDll.h"
-
-class DllDvdNavInterface
-{
-public:
-  virtual ~DllDvdNavInterface() = default;
-  virtual dvdnav_status_t dvdnav_open(dvdnav_t **dest, const char *path)=0;
-  virtual dvdnav_status_t dvdnav_open2(dvdnav_t** dest,
-                                       void*,
-                                       const dvdnav_logger_cb*,
-                                       const char* path) = 0;
-  virtual dvdnav_status_t dvdnav_open_stream(dvdnav_t **dest, void *stream, dvdnav_stream_cb *stream_cb) = 0;
-  virtual dvdnav_status_t dvdnav_open_stream2(dvdnav_t** dest,
-                                              void* stream,
-                                              const dvdnav_logger_cb*,
-                                              dvdnav_stream_cb* stream_cb) = 0;
-  virtual dvdnav_status_t dvdnav_close(dvdnav_t *self)=0;
-  virtual dvdnav_status_t dvdnav_reset(dvdnav_t *self)=0;
-  virtual const char* dvdnav_err_to_string(dvdnav_t *self)=0;
-  virtual dvdnav_status_t dvdnav_set_readahead_flag(dvdnav_t *self, int32_t read_ahead_flag)=0;
-  virtual dvdnav_status_t dvdnav_set_PGC_positioning_flag(dvdnav_t *self, int32_t pgc_based_flag)=0;
-  virtual dvdnav_status_t dvdnav_get_next_cache_block(dvdnav_t *self, uint8_t **buf, int32_t *event, int32_t *len)=0;
-  virtual dvdnav_status_t dvdnav_free_cache_block(dvdnav_t *self, unsigned char *buf)=0;
-  virtual dvdnav_status_t dvdnav_still_skip(dvdnav_t *self)=0;
-  virtual dvdnav_status_t dvdnav_wait_skip(dvdnav_t *self)=0;
-  virtual dvdnav_status_t dvdnav_stop(dvdnav_t *self)=0;
-  virtual dvdnav_status_t dvdnav_button_select(dvdnav_t *self, pci_t *pci, int32_t button)=0;
-  virtual dvdnav_status_t dvdnav_button_activate(dvdnav_t *self, pci_t *pci)=0;
-  virtual dvdnav_status_t dvdnav_upper_button_select(dvdnav_t *self, pci_t *pci)=0;
-  virtual dvdnav_status_t dvdnav_lower_button_select(dvdnav_t *self, pci_t *pci)=0;
-  virtual dvdnav_status_t dvdnav_right_button_select(dvdnav_t *self, pci_t *pci)=0;
-  virtual dvdnav_status_t dvdnav_left_button_select(dvdnav_t *self, pci_t *pci)=0;
-  virtual dvdnav_status_t dvdnav_sector_search(dvdnav_t *self, uint64_t offset, int32_t origin)=0;
-  virtual pci_t* dvdnav_get_current_nav_pci(dvdnav_t *self)=0;
-  virtual dsi_t* dvdnav_get_current_nav_dsi(dvdnav_t *self)=0;
-  virtual dvdnav_status_t dvdnav_get_position(dvdnav_t *self, uint32_t *pos, uint32_t *len)=0;
-  virtual dvdnav_status_t dvdnav_current_title_info(dvdnav_t *self, int32_t *title, int32_t *part)=0;
-  virtual dvdnav_status_t dvdnav_spu_language_select(dvdnav_t *self, char *code)=0;
-  virtual dvdnav_status_t dvdnav_audio_language_select(dvdnav_t *self, char *code)=0;
-  virtual dvdnav_status_t dvdnav_menu_language_select(dvdnav_t *self, char *code)=0;
-  virtual int8_t dvdnav_is_domain_vts(dvdnav_t *self)=0;
-  virtual int8_t dvdnav_get_active_spu_stream(dvdnav_t *self)=0;
-  virtual int8_t dvdnav_get_spu_logical_stream(dvdnav_t *self, uint8_t subp_num)=0;
-  virtual uint16_t dvdnav_spu_stream_to_lang(dvdnav_t *self, uint8_t stream)=0;
-  virtual dvdnav_status_t dvdnav_get_current_highlight(dvdnav_t *self, int32_t *button)=0;
-  virtual dvdnav_status_t dvdnav_menu_call(dvdnav_t *self, DVDMenuID_t menu)=0;
-  virtual dvdnav_status_t dvdnav_prev_pg_search(dvdnav_t *self)=0;
-  virtual dvdnav_status_t dvdnav_next_pg_search(dvdnav_t *self)=0;
-  virtual dvdnav_status_t dvdnav_get_highlight_area(pci_t *nav_pci , int32_t button, int32_t mode, dvdnav_highlight_area_t *highlight)=0;
-  virtual dvdnav_status_t dvdnav_go_up(dvdnav_t *self)=0;
-  virtual int8_t dvdnav_get_active_audio_stream(dvdnav_t *self)=0;
-  virtual uint16_t dvdnav_audio_stream_to_lang(dvdnav_t *self, uint8_t stream)=0;
-  virtual int8_t dvdnav_get_audio_logical_stream(dvdnav_t *self, uint8_t audio_num)=0;
-  virtual dvdnav_status_t dvdnav_set_region_mask(dvdnav_t *self, int32_t region_mask)=0;
-  virtual uint8_t dvdnav_get_video_aspect(dvdnav_t *self)=0;
-  virtual uint8_t dvdnav_get_video_scale_permission(dvdnav_t *self)=0;
-  virtual dvdnav_status_t dvdnav_get_number_of_titles(dvdnav_t *self, int32_t *titles)=0;
-  virtual dvdnav_status_t dvdnav_get_number_of_parts(dvdnav_t *self, int32_t title, int32_t *parts)=0;
-  virtual dvdnav_status_t dvdnav_title_play(dvdnav_t *self, int32_t title)=0;
-  virtual dvdnav_status_t dvdnav_part_play(dvdnav_t *self, int32_t title, int32_t part)=0;
-  virtual dvdnav_status_t dvdnav_get_audio_attr(dvdnav_t * self, int32_t streamid, audio_attr_t* audio_attributes)=0;
-  virtual dvdnav_status_t dvdnav_get_spu_attr(dvdnav_t * self, int32_t streamid, subp_attr_t* stitle_attributes)=0;
-  virtual dvdnav_status_t dvdnav_jump_to_sector_by_time(dvdnav_t* self,
-                                                        uint64_t offset,
-                                                        int32_t origin) = 0;
-  virtual int64_t dvdnav_convert_time(dvd_time_t *time)=0;
-  virtual dvdnav_status_t dvdnav_get_angle_info(dvdnav_t *self, int32_t *current_angle,int32_t *number_of_angles)=0;
-  virtual dvdnav_status_t dvdnav_angle_change(dvdnav_t *self, int32_t angle) = 0;
-  virtual dvdnav_status_t dvdnav_mouse_activate(dvdnav_t *self, pci_t *pci, int32_t x, int32_t y)=0;
-  virtual dvdnav_status_t dvdnav_mouse_select(dvdnav_t *self, pci_t *pci, int32_t x, int32_t y)=0;
-  virtual dvdnav_status_t dvdnav_get_title_string(dvdnav_t *self, const char **title_str)=0;
-  virtual dvdnav_status_t dvdnav_get_serial_string(dvdnav_t *self, const char **serial_str)=0;
-  virtual const char* dvdnav_get_volid_string(dvdnav_t* self) = 0;
-  virtual dvdnav_status_t dvdnav_get_disk_region_mask(dvdnav_t* self, int32_t* region_mask) = 0;
-  virtual uint32_t dvdnav_describe_title_chapters(dvdnav_t* self, uint32_t title, uint64_t** times, uint64_t* duration)=0;
-  virtual int64_t dvdnav_get_current_time(dvdnav_t* self) = 0;
-  virtual int dvdnav_get_video_resolution(dvdnav_t* self, uint32_t* width, uint32_t* height)=0;
-  virtual int8_t dvdnav_get_number_of_streams(dvdnav_t* self, dvdnav_stream_type_t stream_type) = 0;
-  virtual dvdnav_status_t dvdnav_toggle_spu_stream(dvdnav_t* self, uint8_t visibility) = 0;
-  virtual dvdnav_status_t dvdnav_set_active_stream(dvdnav_t* self,
-                                                   uint8_t stream_num,
-                                                   dvdnav_stream_type_t stream_type) = 0;
-  virtual dvdnav_status_t dvdnav_program_play(dvdnav_t* self,
-                                              int32_t title,
-                                              int32_t pgcn,
-                                              int32_t pgn) = 0;
-  virtual dvdnav_status_t dvdnav_current_title_program(dvdnav_t* self,
-                                                       int32_t* title,
-                                                       int32_t* pgcn,
-                                                       int32_t* pgn) = 0;
-};
-
-class DllDvdNav : public DllDynamic, DllDvdNavInterface
-{
-  DECLARE_DLL_WRAPPER(DllDvdNav, DLL_PATH_LIBDVDNAV)
-
-  DEFINE_METHOD2(dvdnav_status_t, dvdnav_open, (dvdnav_t **p1, const char *p2))
-  DEFINE_METHOD4(dvdnav_status_t,
-                 dvdnav_open2,
-                 (dvdnav_t * *p1, void* p2, const dvdnav_logger_cb* p3, const char* p4))
-  DEFINE_METHOD3(dvdnav_status_t, dvdnav_open_stream, (dvdnav_t **p1, void *p2, dvdnav_stream_cb *p3))
-  DEFINE_METHOD4(dvdnav_status_t,
-                 dvdnav_open_stream2,
-                 (dvdnav_t * *p1, void* p2, const dvdnav_logger_cb* p3, dvdnav_stream_cb* p4))
-  DEFINE_METHOD1(dvdnav_status_t, dvdnav_close, (dvdnav_t *p1))
-  DEFINE_METHOD1(dvdnav_status_t, dvdnav_reset, (dvdnav_t *p1))
-  DEFINE_METHOD1(const char*, dvdnav_err_to_string, (dvdnav_t *p1))
-  DEFINE_METHOD2(dvdnav_status_t, dvdnav_set_readahead_flag, (dvdnav_t *p1, int32_t p2))
-  DEFINE_METHOD2(dvdnav_status_t, dvdnav_set_PGC_positioning_flag, (dvdnav_t *p1, int32_t p2))
-  DEFINE_METHOD4(dvdnav_status_t, dvdnav_get_next_cache_block, (dvdnav_t *p1, uint8_t **p2, int32_t *p3, int32_t *p4))
-  DEFINE_METHOD2(dvdnav_status_t, dvdnav_free_cache_block, (dvdnav_t *p1, unsigned char *p2))
-  DEFINE_METHOD1(dvdnav_status_t, dvdnav_still_skip, (dvdnav_t *p1))
-  DEFINE_METHOD1(dvdnav_status_t, dvdnav_wait_skip, (dvdnav_t *p1))
-  DEFINE_METHOD1(dvdnav_status_t, dvdnav_stop, (dvdnav_t *p1))
-  DEFINE_METHOD3(dvdnav_status_t, dvdnav_button_select, (dvdnav_t *p1, pci_t *p2, int32_t p3))
-  DEFINE_METHOD2(dvdnav_status_t, dvdnav_button_activate,(dvdnav_t *p1, pci_t *p2))
-  DEFINE_METHOD2(dvdnav_status_t, dvdnav_upper_button_select, (dvdnav_t *p1, pci_t *p2))
-  DEFINE_METHOD2(dvdnav_status_t, dvdnav_lower_button_select, (dvdnav_t *p1, pci_t *p2))
-  DEFINE_METHOD2(dvdnav_status_t, dvdnav_right_button_select, (dvdnav_t *p1, pci_t *p2))
-  DEFINE_METHOD2(dvdnav_status_t, dvdnav_left_button_select, (dvdnav_t *p1, pci_t *p2))
-  DEFINE_METHOD3(dvdnav_status_t, dvdnav_sector_search, (dvdnav_t *p1, uint64_t p2, int32_t p3))
-  DEFINE_METHOD1(pci_t*, dvdnav_get_current_nav_pci, (dvdnav_t *p1))
-  DEFINE_METHOD1(dsi_t*, dvdnav_get_current_nav_dsi, (dvdnav_t *p1))
-  DEFINE_METHOD3(dvdnav_status_t, dvdnav_get_position, (dvdnav_t *p1, uint32_t *p2, uint32_t *p3))
-  DEFINE_METHOD3(dvdnav_status_t, dvdnav_current_title_info, (dvdnav_t *p1, int32_t *p2, int32_t *p3))
-  DEFINE_METHOD2(dvdnav_status_t, dvdnav_spu_language_select, (dvdnav_t *p1, char *p2))
-  DEFINE_METHOD2(dvdnav_status_t, dvdnav_audio_language_select, (dvdnav_t *p1, char *p2))
-  DEFINE_METHOD2(dvdnav_status_t, dvdnav_menu_language_select, (dvdnav_t *p1, char *p2))
-  DEFINE_METHOD1(int8_t, dvdnav_is_domain_vts, (dvdnav_t *p1))
-  DEFINE_METHOD1(int8_t, dvdnav_get_active_spu_stream, (dvdnav_t *p1))
-  DEFINE_METHOD2(int8_t, dvdnav_get_spu_logical_stream, (dvdnav_t *p1, uint8_t p2))
-  DEFINE_METHOD2(uint16_t, dvdnav_spu_stream_to_lang, (dvdnav_t *p1, uint8_t p2))
-  DEFINE_METHOD2(dvdnav_status_t, dvdnav_get_current_highlight, (dvdnav_t *p1, int32_t *p2))
-  DEFINE_METHOD2(dvdnav_status_t, dvdnav_menu_call, (dvdnav_t *p1, DVDMenuID_t p2))
-  DEFINE_METHOD2(dvdnav_status_t, dvdnav_get_disk_region_mask, (dvdnav_t * p1, int32_t* p2))
-  DEFINE_METHOD1(dvdnav_status_t, dvdnav_prev_pg_search, (dvdnav_t *p1))
-  DEFINE_METHOD1(dvdnav_status_t, dvdnav_next_pg_search, (dvdnav_t *p1))
-  DEFINE_METHOD4(dvdnav_status_t, dvdnav_get_highlight_area, (pci_t *p1, int32_t p2, int32_t p3, dvdnav_highlight_area_t *p4))
-  DEFINE_METHOD1(dvdnav_status_t, dvdnav_go_up, (dvdnav_t *p1))
-  DEFINE_METHOD1(int8_t, dvdnav_get_active_audio_stream, (dvdnav_t *p1))
-  DEFINE_METHOD2(uint16_t, dvdnav_audio_stream_to_lang, (dvdnav_t *p1, uint8_t p2))
-  DEFINE_METHOD2(int8_t, dvdnav_get_audio_logical_stream, (dvdnav_t *p1, uint8_t p2))
-  DEFINE_METHOD2(int8_t, dvdnav_get_number_of_streams, (dvdnav_t * p1, dvdnav_stream_type_t p2))
-  DEFINE_METHOD2(dvdnav_status_t, dvdnav_set_region_mask, (dvdnav_t *p1, int32_t p2))
-  DEFINE_METHOD1(uint8_t, dvdnav_get_video_aspect, (dvdnav_t *p1))
-  DEFINE_METHOD1(uint8_t, dvdnav_get_video_scale_permission, (dvdnav_t *p1))
-  DEFINE_METHOD2(dvdnav_status_t, dvdnav_get_number_of_titles, (dvdnav_t *p1, int32_t *p2))
-  DEFINE_METHOD3(dvdnav_status_t, dvdnav_get_number_of_parts, (dvdnav_t *p1, int32_t p2, int32_t *p3))
-  DEFINE_METHOD2(dvdnav_status_t, dvdnav_title_play, (dvdnav_t *p1, int32_t p2))
-  DEFINE_METHOD3(dvdnav_status_t, dvdnav_part_play, (dvdnav_t *p1, int32_t p2, int32_t p3))
-  DEFINE_METHOD3(dvdnav_status_t, dvdnav_get_audio_attr, (dvdnav_t * p1, int32_t p2, audio_attr_t* p3))
-  DEFINE_METHOD3(dvdnav_status_t, dvdnav_get_spu_attr, (dvdnav_t * p1, int32_t p2, subp_attr_t* p3))
-  DEFINE_METHOD3(dvdnav_status_t, dvdnav_jump_to_sector_by_time, (dvdnav_t * p1, uint64_t p2, int32_t p3))
-  DEFINE_METHOD1(int64_t, dvdnav_convert_time, (dvd_time_t *p1))
-  DEFINE_METHOD3(dvdnav_status_t, dvdnav_get_angle_info, (dvdnav_t *p1, int32_t *p2,int32_t *p3))
-  DEFINE_METHOD2(dvdnav_status_t, dvdnav_angle_change, (dvdnav_t *p1, int32_t p2))
-  DEFINE_METHOD4(dvdnav_status_t, dvdnav_mouse_activate, (dvdnav_t *p1, pci_t *p2, int32_t p3, int32_t p4))
-  DEFINE_METHOD4(dvdnav_status_t, dvdnav_mouse_select, (dvdnav_t *p1, pci_t *p2, int32_t p3, int32_t p4))
-  DEFINE_METHOD2(dvdnav_status_t, dvdnav_get_title_string, (dvdnav_t *p1, const char **p2))
-  DEFINE_METHOD2(dvdnav_status_t, dvdnav_get_serial_string, (dvdnav_t *p1, const char **p2))
-  DEFINE_METHOD1(const char*, dvdnav_get_volid_string, (dvdnav_t * p1))
-  DEFINE_METHOD4(uint32_t, dvdnav_describe_title_chapters, (dvdnav_t* p1, uint32_t p2, uint64_t** p3, uint64_t* p4))
-  DEFINE_METHOD1(int64_t, dvdnav_get_current_time, (dvdnav_t * p1))
-  DEFINE_METHOD3(int, dvdnav_get_video_resolution, (dvdnav_t * p1, uint32_t* p2, uint32_t* p3))
-  DEFINE_METHOD2(dvdnav_status_t, dvdnav_toggle_spu_stream, (dvdnav_t * p1, uint8_t p2))
-  DEFINE_METHOD3(dvdnav_status_t,
-                 dvdnav_set_active_stream,
-                 (dvdnav_t * p1, uint8_t p2, dvdnav_stream_type_t p3))
-  DEFINE_METHOD4(dvdnav_status_t,
-                 dvdnav_program_play,
-                 (dvdnav_t * p1, int32_t p2, int32_t p3, int32_t p4))
-  DEFINE_METHOD4(dvdnav_status_t,
-                 dvdnav_current_title_program,
-                 (dvdnav_t * p1, int32_t* p2, int32_t* p3, int32_t* p4))
-  BEGIN_METHOD_RESOLVE()
-    RESOLVE_METHOD(dvdnav_open)
-    RESOLVE_METHOD(dvdnav_open2)
-    RESOLVE_METHOD(dvdnav_open_stream)
-    RESOLVE_METHOD(dvdnav_open_stream2)
-    RESOLVE_METHOD(dvdnav_close)
-    RESOLVE_METHOD(dvdnav_reset)
-    RESOLVE_METHOD(dvdnav_err_to_string)
-    RESOLVE_METHOD(dvdnav_set_readahead_flag)
-    RESOLVE_METHOD(dvdnav_set_PGC_positioning_flag)
-    RESOLVE_METHOD(dvdnav_get_next_cache_block)
-    RESOLVE_METHOD(dvdnav_free_cache_block)
-    RESOLVE_METHOD(dvdnav_still_skip)
-    RESOLVE_METHOD(dvdnav_wait_skip)
-    RESOLVE_METHOD(dvdnav_stop)
-    RESOLVE_METHOD(dvdnav_get_number_of_streams)
-    RESOLVE_METHOD(dvdnav_get_disk_region_mask)
-    RESOLVE_METHOD(dvdnav_button_select)
-    RESOLVE_METHOD(dvdnav_button_activate)
-    RESOLVE_METHOD(dvdnav_upper_button_select)
-    RESOLVE_METHOD(dvdnav_lower_button_select)
-    RESOLVE_METHOD(dvdnav_right_button_select)
-    RESOLVE_METHOD(dvdnav_left_button_select)
-    RESOLVE_METHOD(dvdnav_sector_search)
-    RESOLVE_METHOD(dvdnav_get_current_nav_pci)
-    RESOLVE_METHOD(dvdnav_get_current_nav_dsi)
-    RESOLVE_METHOD(dvdnav_get_position)
-    RESOLVE_METHOD(dvdnav_current_title_info)
-    RESOLVE_METHOD(dvdnav_spu_language_select)
-    RESOLVE_METHOD(dvdnav_audio_language_select)
-    RESOLVE_METHOD(dvdnav_menu_language_select)
-    RESOLVE_METHOD(dvdnav_is_domain_vts)
-    RESOLVE_METHOD(dvdnav_get_active_spu_stream)
-    RESOLVE_METHOD(dvdnav_get_spu_logical_stream)
-    RESOLVE_METHOD(dvdnav_spu_stream_to_lang)
-    RESOLVE_METHOD(dvdnav_get_current_highlight)
-    RESOLVE_METHOD(dvdnav_menu_call)
-    RESOLVE_METHOD(dvdnav_prev_pg_search)
-    RESOLVE_METHOD(dvdnav_next_pg_search)
-    RESOLVE_METHOD(dvdnav_get_highlight_area)
-    RESOLVE_METHOD(dvdnav_go_up)
-    RESOLVE_METHOD(dvdnav_get_active_audio_stream)
-    RESOLVE_METHOD(dvdnav_audio_stream_to_lang)
-    RESOLVE_METHOD(dvdnav_get_audio_logical_stream)
-    RESOLVE_METHOD(dvdnav_set_region_mask)
-    RESOLVE_METHOD(dvdnav_get_video_aspect)
-    RESOLVE_METHOD(dvdnav_get_video_scale_permission)
-    RESOLVE_METHOD(dvdnav_get_number_of_titles)
-    RESOLVE_METHOD(dvdnav_get_number_of_parts)
-    RESOLVE_METHOD(dvdnav_title_play)
-    RESOLVE_METHOD(dvdnav_part_play)
-    RESOLVE_METHOD(dvdnav_get_audio_attr)
-    RESOLVE_METHOD(dvdnav_get_spu_attr)
-    RESOLVE_METHOD(dvdnav_jump_to_sector_by_time)
-    RESOLVE_METHOD(dvdnav_convert_time)
-    RESOLVE_METHOD(dvdnav_get_angle_info)
-    RESOLVE_METHOD(dvdnav_angle_change)
-    RESOLVE_METHOD(dvdnav_mouse_activate)
-    RESOLVE_METHOD(dvdnav_mouse_select)
-    RESOLVE_METHOD(dvdnav_get_title_string)
-    RESOLVE_METHOD(dvdnav_get_serial_string)
-    RESOLVE_METHOD(dvdnav_get_volid_string)
-    RESOLVE_METHOD(dvdnav_describe_title_chapters)
-    RESOLVE_METHOD(dvdnav_get_current_time)
-    RESOLVE_METHOD(dvdnav_get_video_resolution)
-    RESOLVE_METHOD(dvdnav_toggle_spu_stream)
-    RESOLVE_METHOD(dvdnav_set_active_stream)
-    RESOLVE_METHOD(dvdnav_program_play)
-    RESOLVE_METHOD(dvdnav_current_title_program)
-    END_METHOD_RESOLVE()
-};
-- 
2.43.0


From c75a8769cfff7257e31d009bce5b6f1c6d04d32c Mon Sep 17 00:00:00 2001
From: fuzzard <fuzzard@kodi.tv>
Date: Mon, 27 Jun 2022 19:48:48 +1000
Subject: [PATCH 2/9] WIP!: allow system libs for dvdread/nav/css

---
 CMakeLists.txt                                |   1 +
 cmake/modules/FindLibDvd.cmake                |  10 --
 cmake/modules/FindLibDvdCSS.cmake             | 130 ++++++++-------
 cmake/modules/FindLibDvdNav.cmake             | 148 ++++++++++--------
 cmake/modules/FindLibDvdRead.cmake            | 148 ++++++++++--------
 .../DVDInputStreamNavigator.cpp               |   4 +-
 .../DVDInputStreams/DVDInputStreamNavigator.h |   8 +-
 7 files changed, 242 insertions(+), 207 deletions(-)

diff --git a/CMakeLists.txt b/CMakeLists.txt
index eb648e9a27..ff6d58c1fc 100644
--- a/CMakeLists.txt
+++ b/CMakeLists.txt
@@ -91,6 +91,7 @@ option(ENABLE_INTERNAL_FFMPEG "Enable internal ffmpeg?" OFF)
 dependent_option(ENABLE_INTERNAL_CEC "Enable internal libcec?")
 dependent_option(ENABLE_INTERNAL_FLATBUFFERS "Enable internal flatbuffers?")
 dependent_option(ENABLE_INTERNAL_FMT "Enable internal fmt?")
+dependent_option(ENABLE_INTERNAL_LIBDVD "Enable internal libdvd* libs?")
 dependent_option(ENABLE_INTERNAL_NFS "Enable internal libnfs?")
 dependent_option(ENABLE_INTERNAL_PCRE "Enable internal pcre?")
 dependent_option(ENABLE_INTERNAL_RapidJSON "Enable internal rapidjson?")
diff --git a/cmake/modules/FindLibDvd.cmake b/cmake/modules/FindLibDvd.cmake
index dd7d8a26d2..91e98d3d46 100644
--- a/cmake/modules/FindLibDvd.cmake
+++ b/cmake/modules/FindLibDvd.cmake
@@ -7,16 +7,6 @@ unset(FPHSA_NAME_MISMATCHED)
 
 set(_dvdlibs ${LIBDVDREAD_LIBRARY} ${LIBDVDCSS_LIBRARY})
 
-if(NOT CORE_SYSTEM_NAME MATCHES windows)
-  # link a shared dvdnav library that includes the whole archives of dvdread and dvdcss as well
-  # the quotes around _dvdlibs are on purpose, since we want to pass a list to the function that will be unpacked automatically
-  core_link_library(${LIBDVDNAV_LIBRARY} system/players/VideoPlayer/libdvdnav libdvdnav archives "${_dvdlibs}")
-else()
-  set(LIBDVD_TARGET_DIR .)
-  copy_file_to_buildtree(${DEPENDS_PATH}/bin/libdvdnav.dll DIRECTORY ${LIBDVD_TARGET_DIR})
-  set_property(GLOBAL APPEND PROPERTY INTERNAL_DEPS_PROP LibDvdNav::LibDvdNav)
-endif()
-
 set(LIBDVD_INCLUDE_DIRS ${LIBDVDREAD_INCLUDE_DIR} ${LIBDVDNAV_INCLUDE_DIR})
 set(LIBDVD_LIBRARIES ${LIBDVDNAV_LIBRARY} ${LIBDVDREAD_LIBRARY})
 if(TARGET LibDvdCSS::LibDvdCSS)
diff --git a/cmake/modules/FindLibDvdCSS.cmake b/cmake/modules/FindLibDvdCSS.cmake
index 742efd5583..1179ae24ac 100644
--- a/cmake/modules/FindLibDvdCSS.cmake
+++ b/cmake/modules/FindLibDvdCSS.cmake
@@ -12,77 +12,89 @@ if(ENABLE_DVDCSS)
 
   set(MODULE_LC libdvdcss)
 
-  # We require this due to the odd nature of github URL's compared to our other tarball
-  # mirror system. If User sets LIBDVDCSS_URL or libdvdcss_URL, allow get_filename_component in SETUP_BUILD_VARS
-  if(LIBDVDCSS_URL OR ${MODULE_LC}_URL)
-    if(${MODULE_LC}_URL)
-      set(LIBDVDCSS_URL ${${MODULE_LC}_URL})
+  if(ENABLE_INTERNAL_LIBDVD)
+
+    # We require this due to the odd nature of github URL's compared to our other tarball
+    # mirror system. If User sets LIBDVDCSS_URL or libdvdcss_URL, allow get_filename_component in SETUP_BUILD_VARS
+    if(LIBDVDCSS_URL OR ${MODULE_LC}_URL)
+      set(LIBDVDCSS_URL_PROVIDED TRUE)
     endif()
-    set(LIBDVDCSS_URL_PROVIDED TRUE)
-  endif()
 
-  SETUP_BUILD_VARS()
+    SETUP_BUILD_VARS()
 
-  if(NOT LIBDVDCSS_URL_PROVIDED)
-    # override LIBDVDCSS_URL_PROVIDED due to tar naming when retrieved from github release
-    set(LIBDVDCSS_URL ${LIBDVDCSS_BASE_URL}/archive/${LIBDVDCSS_VER}.tar.gz)
-  endif()
+    if(NOT LIBDVDCSS_URL_PROVIDED)
+      # override LIBDVDCSS_URL_PROVIDED due to tar naming when retrieved from github release
+      set(LIBDVDCSS_URL ${LIBDVDCSS_BASE_URL}/archive/${LIBDVDCSS_VER}.tar.gz)
+    endif()
 
-  set(LIBDVDCSS_VERSION ${${MODULE}_VER})
-
-  set(HOST_ARCH ${ARCH})
-  if(CORE_SYSTEM_NAME STREQUAL android)
-    if(ARCH STREQUAL arm)
-      set(HOST_ARCH arm-linux-androideabi)
-    elseif(ARCH STREQUAL aarch64)
-      set(HOST_ARCH aarch64-linux-android)
-    elseif(ARCH STREQUAL i486-linux)
-      set(HOST_ARCH i686-linux-android)
-    elseif(ARCH STREQUAL x86_64)
-      set(HOST_ARCH x86_64-linux-android)
+    set(LIBDVDCSS_VERSION ${${MODULE}_VER})
+
+    set(HOST_ARCH ${ARCH})
+    if(CORE_SYSTEM_NAME STREQUAL android)
+      if(ARCH STREQUAL arm)
+        set(HOST_ARCH arm-linux-androideabi)
+      elseif(ARCH STREQUAL aarch64)
+        set(HOST_ARCH aarch64-linux-android)
+      elseif(ARCH STREQUAL i486-linux)
+        set(HOST_ARCH i686-linux-android)
+      elseif(ARCH STREQUAL x86_64)
+        set(HOST_ARCH x86_64-linux-android)
+      endif()
+    elseif(CORE_SYSTEM_NAME STREQUAL windowsstore)
+      set(LIBDVD_ADDITIONAL_ARGS "-DCMAKE_SYSTEM_NAME=${CMAKE_SYSTEM_NAME}" "-DCMAKE_SYSTEM_VERSION=${CMAKE_SYSTEM_VERSION}")
+      set(${MODULE}_CXX_FLAGS "/Zc:twoPhase-")
     endif()
-  elseif(CORE_SYSTEM_NAME STREQUAL windowsstore)
-    set(LIBDVD_ADDITIONAL_ARGS "-DCMAKE_SYSTEM_NAME=${CMAKE_SYSTEM_NAME}" "-DCMAKE_SYSTEM_VERSION=${CMAKE_SYSTEM_VERSION}")
-    set(${MODULE}_CXX_FLAGS "/Zc:twoPhase-")
-  endif()
 
-  if(APPLE)
-    set(LIBDVDCSS_FLAGS " -framework CoreFoundation")
-    if(NOT CORE_SYSTEM_NAME STREQUAL darwin_embedded)
-      string(APPEND LIBDVDCSS_FLAGS " -framework IOKit")
+    if(APPLE)
+      set(LIBDVDCSS_FLAGS " -framework CoreFoundation")
+      if(NOT CORE_SYSTEM_NAME STREQUAL darwin_embedded)
+        string(APPEND LIBDVDCSS_FLAGS " -framework IOKit")
+      endif()
     endif()
-  endif()
 
-  if(CORE_SYSTEM_NAME MATCHES windows)
-    set(CMAKE_ARGS -DDUMMY_DEFINE=ON
-                   ${LIBDVD_ADDITIONAL_ARGS})
+    if(CORE_SYSTEM_NAME MATCHES windows)
+      set(CMAKE_ARGS -DDUMMY_DEFINE=ON
+                     ${LIBDVD_ADDITIONAL_ARGS})
+    else()
+      find_program(AUTORECONF autoreconf REQUIRED)
+      if (CMAKE_HOST_SYSTEM_NAME MATCHES "(Free|Net|Open)BSD")
+        find_program(MAKE_EXECUTABLE gmake)
+      endif()
+      find_program(MAKE_EXECUTABLE make REQUIRED)
+
+      set(CONFIGURE_COMMAND ${AUTORECONF} -vif
+                    COMMAND ac_cv_path_GIT= ./configure
+                            --target=${HOST_ARCH}
+                            --host=${HOST_ARCH}
+                            --disable-doc
+                            --enable-static
+                            --disable-shared
+                            --with-pic
+                            --prefix=${DEPENDS_PATH}
+                            --libdir=${DEPENDS_PATH}/lib
+                            "CC=${CMAKE_C_COMPILER}"
+                            "CFLAGS=${CMAKE_C_FLAGS}"
+                            "LDFLAGS=${CMAKE_EXE_LINKER_FLAGS} ${LIBDVDCSS_FLAGS}")
+      set(BUILD_COMMAND ${MAKE_EXECUTABLE})
+      set(INSTALL_COMMAND ${MAKE_EXECUTABLE} install)
+      set(BUILD_IN_SOURCE 1)
+    endif()
+
+    BUILD_DEP_TARGET()
+
   else()
-    find_program(AUTORECONF autoreconf REQUIRED)
-    if (CMAKE_HOST_SYSTEM_NAME MATCHES "(Free|Net|Open)BSD")
-      find_program(MAKE_EXECUTABLE gmake)
+    if(PKG_CONFIG_FOUND)
+      pkg_check_modules(PC_DVDCSS libdvdcss QUIET)
     endif()
-    find_program(MAKE_EXECUTABLE make REQUIRED)
-
-    set(CONFIGURE_COMMAND ${AUTORECONF} -vif
-                  COMMAND ac_cv_path_GIT= ./configure
-                          --target=${HOST_ARCH}
-                          --host=${HOST_ARCH}
-                          --disable-doc
-                          --enable-static
-                          --disable-shared
-                          --with-pic
-                          --prefix=${DEPENDS_PATH}
-                          --libdir=${DEPENDS_PATH}/lib
-                          "CC=${CMAKE_C_COMPILER}"
-                          "CFLAGS=${CMAKE_C_FLAGS}"
-                          "LDFLAGS=${CMAKE_EXE_LINKER_FLAGS} ${LIBDVDCSS_FLAGS}")
-    set(BUILD_COMMAND ${MAKE_EXECUTABLE})
-    set(INSTALL_COMMAND ${MAKE_EXECUTABLE} install)
-    set(BUILD_IN_SOURCE 1)
-  endif()
 
-  BUILD_DEP_TARGET()
+    find_path(LIBDVDCSS_INCLUDE_DIR NAMES dvdcss.h
+                                    PATH_SUFFIXES dvdcss
+                                    PATHS ${PC_DVDCSS_INCLUDEDIR})
+    find_library(LIBDVDCSS_LIBRARY NAMES dvdcss libdvdcss
+                                   PATHS ${PC_DVDCSS_LIBDIR})
 
+    set(LIBDVDCSS_VERSION ${PC_DVDCSS_VERSION})
+  endif()
 endif()
 
 include(SelectLibraryConfigurations)
diff --git a/cmake/modules/FindLibDvdNav.cmake b/cmake/modules/FindLibDvdNav.cmake
index ffd8d9d4d3..b8f426d210 100644
--- a/cmake/modules/FindLibDvdNav.cmake
+++ b/cmake/modules/FindLibDvdNav.cmake
@@ -19,89 +19,101 @@ if(NOT TARGET LibDvdNav::LibDvdNav)
 
   set(MODULE_LC libdvdnav)
 
-  # We require this due to the odd nature of github URL's compared to our other tarball
-  # mirror system. If User sets LIBDVDNAV_URL or libdvdnav_URL, allow get_filename_component in SETUP_BUILD_VARS
-  if(LIBDVDNAV_URL OR ${MODULE_LC}_URL)
-    if(${MODULE_LC}_URL)
-      set(LIBDVDNAV_URL ${${MODULE_LC}_URL})
+  if(ENABLE_INTERNAL_LIBDVD)
+
+    # We require this due to the odd nature of github URL's compared to our other tarball
+    # mirror system. If User sets LIBDVDNAV_URL or libdvdnav_URL, allow get_filename_component in SETUP_BUILD_VARS
+    if(LIBDVDNAV_URL OR ${MODULE_LC}_URL)
+      set(LIBDVDNAV_URL_PROVIDED TRUE)
     endif()
-    set(LIBDVDNAV_URL_PROVIDED TRUE)
-  endif()
 
-  SETUP_BUILD_VARS()
+    SETUP_BUILD_VARS()
 
-  if(NOT LIBDVDNAV_URL_PROVIDED)
-    # override LIBDVDNAV_URL due to tar naming when retrieved from github release
-    set(LIBDVDNAV_URL ${LIBDVDNAV_BASE_URL}/archive/${LIBDVDNAV_VER}.tar.gz)
-  endif()
+    if(NOT LIBDVDNAV_URL_PROVIDED)
+      # override LIBDVDNAV_URL due to tar naming when retrieved from github release
+      set(LIBDVDNAV_URL ${LIBDVDNAV_BASE_URL}/archive/${LIBDVDNAV_VER}.tar.gz)
+    endif()
 
-  set(LIBDVDNAV_VERSION ${${MODULE}_VER})
-
-  set(HOST_ARCH ${ARCH})
-  if(CORE_SYSTEM_NAME STREQUAL android)
-    if(ARCH STREQUAL arm)
-      set(HOST_ARCH arm-linux-androideabi)
-    elseif(ARCH STREQUAL aarch64)
-      set(HOST_ARCH aarch64-linux-android)
-    elseif(ARCH STREQUAL i486-linux)
-      set(HOST_ARCH i686-linux-android)
-    elseif(ARCH STREQUAL x86_64)
-      set(HOST_ARCH x86_64-linux-android)
+    set(LIBDVDNAV_VERSION ${${MODULE}_VER})
+
+    set(HOST_ARCH ${ARCH})
+    if(CORE_SYSTEM_NAME STREQUAL android)
+      if(ARCH STREQUAL arm)
+        set(HOST_ARCH arm-linux-androideabi)
+      elseif(ARCH STREQUAL aarch64)
+        set(HOST_ARCH aarch64-linux-android)
+      elseif(ARCH STREQUAL i486-linux)
+        set(HOST_ARCH i686-linux-android)
+      elseif(ARCH STREQUAL x86_64)
+        set(HOST_ARCH x86_64-linux-android)
+      endif()
+    elseif(CORE_SYSTEM_NAME STREQUAL windowsstore)
+      set(LIBDVD_ADDITIONAL_ARGS "-DCMAKE_SYSTEM_NAME=${CMAKE_SYSTEM_NAME}" "-DCMAKE_SYSTEM_VERSION=${CMAKE_SYSTEM_VERSION}")
     endif()
-  elseif(CORE_SYSTEM_NAME STREQUAL windowsstore)
-    set(LIBDVD_ADDITIONAL_ARGS "-DCMAKE_SYSTEM_NAME=${CMAKE_SYSTEM_NAME}" "-DCMAKE_SYSTEM_VERSION=${CMAKE_SYSTEM_VERSION}")
-  endif()
 
-  string(APPEND LIBDVDNAV_CFLAGS "-D_XBMC")
+    string(APPEND LIBDVDNAV_CFLAGS "-D_XBMC")
 
-  if(APPLE)
-    set(LIBDVDNAV_LDFLAGS "-framework CoreFoundation")
-    string(APPEND LIBDVDNAV_CFLAGS " -D__DARWIN__")
-    if(NOT CORE_SYSTEM_NAME STREQUAL darwin_embedded)
-      string(APPEND LIBDVDNAV_LDFLAGS " -framework IOKit")
+    if(APPLE)
+      set(LIBDVDNAV_LDFLAGS "-framework CoreFoundation")
+      string(APPEND LIBDVDNAV_CFLAGS " -D__DARWIN__")
+      if(NOT CORE_SYSTEM_NAME STREQUAL darwin_embedded)
+        string(APPEND LIBDVDNAV_LDFLAGS " -framework IOKit")
+      endif()
     endif()
-  endif()
 
-  if(CORE_SYSTEM_NAME MATCHES windows)
-    set(CMAKE_ARGS -DDUMMY_DEFINE=ON
-                   ${LIBDVD_ADDITIONAL_ARGS})
-  else()
+    if(CORE_SYSTEM_NAME MATCHES windows)
+      set(CMAKE_ARGS -DDUMMY_DEFINE=ON
+                     ${LIBDVD_ADDITIONAL_ARGS})
+    else()
+
+      string(APPEND LIBDVDNAV_CFLAGS " -I$<TARGET_PROPERTY:LibDvdRead::LibDvdRead,INTERFACE_INCLUDE_DIRECTORIES>")
+
+      if(TARGET LibDvdCSS::LibDvdCSS)
+        string(APPEND LIBDVDNAV_CFLAGS " -I$<TARGET_PROPERTY:LibDvdCSS::LibDvdCSS,INTERFACE_INCLUDE_DIRECTORIES> $<$<TARGET_EXISTS:LibDvdCSS::LibDvdCSS>:-D$<TARGET_PROPERTY:LibDvdCSS::LibDvdCSS,INTERFACE_COMPILE_DEFINITIONS>>")
+      endif()
+
+      find_program(AUTORECONF autoreconf REQUIRED)
+      if (CMAKE_HOST_SYSTEM_NAME MATCHES "(Free|Net|Open)BSD")
+        find_program(MAKE_EXECUTABLE gmake)
+      endif()
+      find_program(MAKE_EXECUTABLE make REQUIRED)
+
+      set(CONFIGURE_COMMAND ${AUTORECONF} -vif
+                    COMMAND ac_cv_path_GIT= ./configure
+                            --target=${HOST_ARCH}
+                            --host=${HOST_ARCH}
+                            --enable-static
+                            --disable-shared
+                            --with-pic
+                            --prefix=${DEPENDS_PATH}
+                            --libdir=${DEPENDS_PATH}/lib
+                            "CC=${CMAKE_C_COMPILER}"
+                            "CFLAGS=${CMAKE_C_FLAGS} ${LIBDVDNAV_CFLAGS}"
+                            "LDFLAGS=${CMAKE_EXE_LINKER_FLAGS} ${LIBDVDNAV_LDFLAGS}"
+                            "PKG_CONFIG_PATH=${DEPENDS_PATH}/lib/pkgconfig")
+
+      set(BUILD_COMMAND ${MAKE_EXECUTABLE})
+      set(INSTALL_COMMAND ${MAKE_EXECUTABLE} install)
+      set(BUILD_IN_SOURCE 1)
+    endif()
 
-    string(APPEND LIBDVDNAV_CFLAGS " -I$<TARGET_PROPERTY:LibDvdRead::LibDvdRead,INTERFACE_INCLUDE_DIRECTORIES>")
+    BUILD_DEP_TARGET()
 
-    if(TARGET LibDvdCSS::LibDvdCSS)
-      string(APPEND LIBDVDNAV_CFLAGS " -I$<TARGET_PROPERTY:LibDvdCSS::LibDvdCSS,INTERFACE_INCLUDE_DIRECTORIES> $<$<TARGET_EXISTS:LibDvdCSS::LibDvdCSS>:-D$<TARGET_PROPERTY:LibDvdCSS::LibDvdCSS,INTERFACE_COMPILE_DEFINITIONS>>")
+    if(TARGET LibDvdRead::LibDvdRead)
+      add_dependencies(libdvdnav LibDvdRead::LibDvdRead)
     endif()
-
-    find_program(AUTORECONF autoreconf REQUIRED)
-    if (CMAKE_HOST_SYSTEM_NAME MATCHES "(Free|Net|Open)BSD")
-      find_program(MAKE_EXECUTABLE gmake)
+  else()
+    if(PKG_CONFIG_FOUND)
+      pkg_check_modules(PC_DVDNAV dvdnav QUIET)
     endif()
-    find_program(MAKE_EXECUTABLE make REQUIRED)
-
-    set(CONFIGURE_COMMAND ${AUTORECONF} -vif
-                  COMMAND ac_cv_path_GIT= ./configure
-                          --target=${HOST_ARCH}
-                          --host=${HOST_ARCH}
-                          --enable-static
-                          --disable-shared
-                          --with-pic
-                          --prefix=${DEPENDS_PATH}
-                          --libdir=${DEPENDS_PATH}/lib
-                          "CC=${CMAKE_C_COMPILER}"
-                          "CFLAGS=${CMAKE_C_FLAGS} ${LIBDVDNAV_CFLAGS}"
-                          "LDFLAGS=${CMAKE_EXE_LINKER_FLAGS} ${LIBDVDNAV_LDFLAGS}"
-                          "PKG_CONFIG_PATH=${DEPENDS_PATH}/lib/pkgconfig")
-
-    set(BUILD_COMMAND ${MAKE_EXECUTABLE})
-    set(INSTALL_COMMAND ${MAKE_EXECUTABLE} install)
-    set(BUILD_IN_SOURCE 1)
-  endif()
 
-  BUILD_DEP_TARGET()
+    find_path(LIBDVDNAV_INCLUDE_DIR NAMES dvdnav.h
+                                    PATH_SUFFIXES dvdnav
+                                    PATHS ${PC_DVDNAV_INCLUDEDIR})
+    find_library(LIBDVDNAV_LIBRARY NAMES dvdnav libdvdnav
+                                   PATHS ${PC_DVDNAV_LIBDIR})
 
-  if(TARGET LibDvdRead::LibDvdRead)
-    add_dependencies(libdvdnav LibDvdRead::LibDvdRead)
+    set(LIBDVDNAV_VERSION ${PC_DVDNAV_VERSION})
   endif()
 endif()
 
diff --git a/cmake/modules/FindLibDvdRead.cmake b/cmake/modules/FindLibDvdRead.cmake
index b67ff904ed..bac0f23597 100644
--- a/cmake/modules/FindLibDvdRead.cmake
+++ b/cmake/modules/FindLibDvdRead.cmake
@@ -21,89 +21,101 @@ if(NOT TARGET LibDvdRead::LibDvdRead)
 
   set(MODULE_LC libdvdread)
 
-  # We require this due to the odd nature of github URL's compared to our other tarball
-  # mirror system. If User sets LIBDVDREAD_URL or libdvdread_URL, allow get_filename_component in SETUP_BUILD_VARS
-  if(LIBDVDREAD_URL OR ${MODULE_LC}_URL)
-    if(${MODULE_LC}_URL)
-      set(LIBDVDREAD_URL ${${MODULE_LC}_URL})
+  if(ENABLE_INTERNAL_LIBDVD)
+
+    # We require this due to the odd nature of github URL's compared to our other tarball
+    # mirror system. If User sets LIBDVDREAD_URL or libdvdread_URL, allow get_filename_component in SETUP_BUILD_VARS
+    if(LIBDVDREAD_URL OR ${MODULE_LC}_URL)
+      set(LIBDVDREAD_URL_PROVIDED TRUE)
     endif()
-    set(LIBDVDREAD_URL_PROVIDED TRUE)
-  endif()
 
-  SETUP_BUILD_VARS()
+    SETUP_BUILD_VARS()
 
-  if(NOT LIBDVDREAD_URL_PROVIDED)
-    # override LIBDVDREAD_URL due to tar naming when retrieved from github release
-    set(LIBDVDREAD_URL ${LIBDVDREAD_BASE_URL}/archive/${LIBDVDREAD_VER}.tar.gz)
-  endif()
+    if(NOT LIBDVDREAD_URL_PROVIDED)
+      # override LIBDVDREAD_URL due to tar naming when retrieved from github release
+      set(LIBDVDREAD_URL ${LIBDVDREAD_BASE_URL}/archive/${LIBDVDREAD_VER}.tar.gz)
+    endif()
 
-  set(LIBDVDREAD_VERSION ${${MODULE}_VER})
-
-  set(HOST_ARCH ${ARCH})
-  if(CORE_SYSTEM_NAME STREQUAL android)
-    if(ARCH STREQUAL arm)
-      set(HOST_ARCH arm-linux-androideabi)
-    elseif(ARCH STREQUAL aarch64)
-      set(HOST_ARCH aarch64-linux-android)
-    elseif(ARCH STREQUAL i486-linux)
-      set(HOST_ARCH i686-linux-android)
-    elseif(ARCH STREQUAL x86_64)
-      set(HOST_ARCH x86_64-linux-android)
+    set(LIBDVDREAD_VERSION ${${MODULE}_VER})
+
+    set(HOST_ARCH ${ARCH})
+    if(CORE_SYSTEM_NAME STREQUAL android)
+      if(ARCH STREQUAL arm)
+        set(HOST_ARCH arm-linux-androideabi)
+      elseif(ARCH STREQUAL aarch64)
+        set(HOST_ARCH aarch64-linux-android)
+      elseif(ARCH STREQUAL i486-linux)
+        set(HOST_ARCH i686-linux-android)
+      elseif(ARCH STREQUAL x86_64)
+        set(HOST_ARCH x86_64-linux-android)
+      endif()
+    elseif(CORE_SYSTEM_NAME STREQUAL windowsstore)
+      set(LIBDVD_ADDITIONAL_ARGS "-DCMAKE_SYSTEM_NAME=${CMAKE_SYSTEM_NAME}" "-DCMAKE_SYSTEM_VERSION=${CMAKE_SYSTEM_VERSION}")
     endif()
-  elseif(CORE_SYSTEM_NAME STREQUAL windowsstore)
-    set(LIBDVD_ADDITIONAL_ARGS "-DCMAKE_SYSTEM_NAME=${CMAKE_SYSTEM_NAME}" "-DCMAKE_SYSTEM_VERSION=${CMAKE_SYSTEM_VERSION}")
-  endif()
 
-  string(APPEND LIBDVDREAD_CFLAGS "-D_XBMC")
+    string(APPEND LIBDVDREAD_CFLAGS "-D_XBMC")
 
-  if(APPLE)
-    set(LIBDVDREAD_LDFLAGS "-framework CoreFoundation")
-    string(APPEND LIBDVDREAD_CFLAGS " -D__DARWIN__")
-    if(NOT CORE_SYSTEM_NAME STREQUAL darwin_embedded)
-      string(APPEND LIBDVDREAD_LDFLAGS " -framework IOKit")
+    if(APPLE)
+      set(LIBDVDREAD_LDFLAGS "-framework CoreFoundation")
+      string(APPEND LIBDVDREAD_CFLAGS " -D__DARWIN__")
+      if(NOT CORE_SYSTEM_NAME STREQUAL darwin_embedded)
+        string(APPEND LIBDVDREAD_LDFLAGS " -framework IOKit")
+      endif()
     endif()
-  endif()
 
-  if(CORE_SYSTEM_NAME MATCHES windows)
-    set(CMAKE_ARGS -DDUMMY_DEFINE=ON
-                   ${LIBDVD_ADDITIONAL_ARGS})
-  else()
+    if(CORE_SYSTEM_NAME MATCHES windows)
+      set(CMAKE_ARGS -DDUMMY_DEFINE=ON
+                     ${LIBDVD_ADDITIONAL_ARGS})
+    else()
+
+      if(TARGET LibDvdCSS::LibDvdCSS)
+        string(APPEND LIBDVDREAD_CFLAGS " -I$<TARGET_PROPERTY:LibDvdCSS::LibDvdCSS,INTERFACE_INCLUDE_DIRECTORIES> $<TARGET_PROPERTY:LibDvdCSS::LibDvdCSS,INTERFACE_COMPILE_DEFINITIONS>")
+        string(APPEND with-css "--with-libdvdcss")
+      endif()
+
+      find_program(AUTORECONF autoreconf REQUIRED)
+      if (CMAKE_HOST_SYSTEM_NAME MATCHES "(Free|Net|Open)BSD")
+        find_program(MAKE_EXECUTABLE gmake)
+      endif()
+      find_program(MAKE_EXECUTABLE make REQUIRED)
+
+      set(CONFIGURE_COMMAND ${AUTORECONF} -vif
+                    COMMAND ac_cv_path_GIT= ./configure
+                            --target=${HOST_ARCH}
+                            --host=${HOST_ARCH}
+                            --enable-static
+                            --disable-shared
+                            --with-pic
+                            --prefix=${DEPENDS_PATH}
+                            --libdir=${DEPENDS_PATH}/lib
+                            ${with-css}
+                            "CC=${CMAKE_C_COMPILER}"
+                            "CFLAGS=${CMAKE_C_FLAGS} ${LIBDVDREAD_CFLAGS}"
+                            "LDFLAGS=${CMAKE_EXE_LINKER_FLAGS} ${LIBDVDREAD_LDFLAGS}"
+                            "PKG_CONFIG_PATH=${DEPENDS_PATH}/lib/pkgconfig")
+
+      set(BUILD_COMMAND ${MAKE_EXECUTABLE})
+      set(INSTALL_COMMAND ${MAKE_EXECUTABLE} install)
+      set(BUILD_IN_SOURCE 1)
+    endif()
+
+    BUILD_DEP_TARGET()
 
     if(TARGET LibDvdCSS::LibDvdCSS)
-      string(APPEND LIBDVDREAD_CFLAGS " -I$<TARGET_PROPERTY:LibDvdCSS::LibDvdCSS,INTERFACE_INCLUDE_DIRECTORIES> $<$<TARGET_EXISTS:LibDvdCSS::LibDvdCSS>:-D$<TARGET_PROPERTY:LibDvdCSS::LibDvdCSS,INTERFACE_COMPILE_DEFINITIONS>>")
-      string(APPEND with-css "--with-libdvdcss")
+      add_dependencies(libdvdread LibDvdCSS::LibDvdCSS)
     endif()
-
-    find_program(AUTORECONF autoreconf REQUIRED)
-    if (CMAKE_HOST_SYSTEM_NAME MATCHES "(Free|Net|Open)BSD")
-      find_program(MAKE_EXECUTABLE gmake)
+  else()
+    if(PKG_CONFIG_FOUND)
+      pkg_check_modules(PC_DVDREAD dvdread QUIET)
     endif()
-    find_program(MAKE_EXECUTABLE make REQUIRED)
-
-    set(CONFIGURE_COMMAND ${AUTORECONF} -vif
-                  COMMAND ac_cv_path_GIT= ./configure
-                          --target=${HOST_ARCH}
-                          --host=${HOST_ARCH}
-                          --enable-static
-                          --disable-shared
-                          --with-pic
-                          --prefix=${DEPENDS_PATH}
-                          --libdir=${DEPENDS_PATH}/lib
-                          ${with-css}
-                          "CC=${CMAKE_C_COMPILER}"
-                          "CFLAGS=${CMAKE_C_FLAGS} ${LIBDVDREAD_CFLAGS}"
-                          "LDFLAGS=${CMAKE_EXE_LINKER_FLAGS} ${LIBDVDREAD_LDFLAGS}"
-                          "PKG_CONFIG_PATH=${DEPENDS_PATH}/lib/pkgconfig")
-
-    set(BUILD_COMMAND ${MAKE_EXECUTABLE})
-    set(INSTALL_COMMAND ${MAKE_EXECUTABLE} install)
-    set(BUILD_IN_SOURCE 1)
-  endif()
 
-  BUILD_DEP_TARGET()
+    find_path(LIBDVDREAD_INCLUDE_DIR NAMES dvd_reader.h
+                                     PATH_SUFFIXES dvdread
+                                     PATHS ${PC_DVDREAD_INCLUDEDIR})
+    find_library(LIBDVDREAD_LIBRARY NAMES dvdread libdvdread
+                                    PATHS ${PC_DVDREAD_LIBDIR})
 
-  if(TARGET LibDvdCSS::LibDvdCSS)
-    add_dependencies(libdvdread LibDvdCSS::LibDvdCSS)
+    set(LIBDVDREAD_VERSION ${PC_DVDREAD_VERSION})
   endif()
 endif()
 
diff --git a/xbmc/cores/VideoPlayer/DVDInputStreams/DVDInputStreamNavigator.cpp b/xbmc/cores/VideoPlayer/DVDInputStreams/DVDInputStreamNavigator.cpp
index 75f00b0051..73c25215f3 100644
--- a/xbmc/cores/VideoPlayer/DVDInputStreams/DVDInputStreamNavigator.cpp
+++ b/xbmc/cores/VideoPlayer/DVDInputStreams/DVDInputStreamNavigator.cpp
@@ -33,6 +33,8 @@
 
 #include <memory>
 
+#include <sys/uio.h>
+
 namespace
 {
 constexpr int HOLDMODE_NONE = 0;
@@ -1423,7 +1425,7 @@ std::string CDVDInputStreamNavigator::GetDVDVolIdString()
   if (!m_dvdnav)
     return "";
 
-  const char* volIdTmp = m_dll.dvdnav_get_volid_string(m_dvdnav);
+  const char* volIdTmp = dvdnav_get_volid_string(m_dvdnav);
   if (volIdTmp)
   {
     std::string volId{volIdTmp};
diff --git a/xbmc/cores/VideoPlayer/DVDInputStreams/DVDInputStreamNavigator.h b/xbmc/cores/VideoPlayer/DVDInputStreams/DVDInputStreamNavigator.h
index e7e2d809ff..a6c7683548 100644
--- a/xbmc/cores/VideoPlayer/DVDInputStreams/DVDInputStreamNavigator.h
+++ b/xbmc/cores/VideoPlayer/DVDInputStreams/DVDInputStreamNavigator.h
@@ -17,9 +17,15 @@
 #include "cores/MenuType.h"
 #include "utils/Geometry.h"
 
+#ifdef __cplusplus
+extern "C"
+{
+#endif
 #include <dvdnav/dvdnav.h>
 #include <dvdnav/dvd_types.h>
-
+#ifdef __cplusplus
+}
+#endif
 #include <string>
 
 #define DVD_VIDEO_BLOCKSIZE         DVD_VIDEO_LB_LEN // 2048 bytes
-- 
2.43.0


From f1cccf543a7d9fcbd6642405b8c08a10a7a09770 Mon Sep 17 00:00:00 2001
From: enen92 <92enen@gmail.com>
Date: Tue, 26 Jul 2022 23:43:21 +0100
Subject: [PATCH 3/9] Add dvdcallbacks for vfs files

---
 .../DVDInputStreamNavigator.cpp               |  45 +++---
 xbmc/filesystem/CMakeLists.txt                |   2 +
 xbmc/filesystem/DvdCallback.cpp               | 150 ++++++++++++++++++
 xbmc/filesystem/DvdCallback.h                 |  47 ++++++
 4 files changed, 218 insertions(+), 26 deletions(-)
 create mode 100644 xbmc/filesystem/DvdCallback.cpp
 create mode 100644 xbmc/filesystem/DvdCallback.h

diff --git a/xbmc/cores/VideoPlayer/DVDInputStreams/DVDInputStreamNavigator.cpp b/xbmc/cores/VideoPlayer/DVDInputStreams/DVDInputStreamNavigator.cpp
index 73c25215f3..46e4f79fa7 100644
--- a/xbmc/cores/VideoPlayer/DVDInputStreams/DVDInputStreamNavigator.cpp
+++ b/xbmc/cores/VideoPlayer/DVDInputStreams/DVDInputStreamNavigator.cpp
@@ -8,6 +8,9 @@
 
 #include "DVDInputStreamNavigator.h"
 
+#include "filesystem/IFileTypes.h"
+#include "filesystem/DvdCallback.h"
+#include "utils/LangCodeExpander.h"
 #include "../DVDDemuxSPU.h"
 #include "LangInfo.h"
 #include "ServiceBroker.h"
@@ -73,7 +76,8 @@ constexpr int DVD_AUDIO_LANG_EXT_DIRECTORSCOMMENTS2 = 4;
 static int dvd_inputstreamnavigator_cb_seek(void * p_stream, uint64_t i_pos);
 static int dvd_inputstreamnavigator_cb_read(void * p_stream, void * buffer, int i_read);
 static int dvd_inputstreamnavigator_cb_readv(void * p_stream, void * p_iovec, int i_blocks);
-static void dvd_logger(void* priv, dvdnav_logger_level_t level, const char* fmt, va_list va);
+
+static dvdnav_filesystem kodiDvdFilesystem;
 
 CDVDInputStreamNavigator::CDVDInputStreamNavigator(IVideoPlayer* player, const CFileItem& fileitem)
   : CDVDInputStream(DVDSTREAM_TYPE_DVD, fileitem), m_pstream(nullptr)
@@ -142,7 +146,7 @@ bool CDVDInputStreamNavigator::Open()
 
 #if DVDNAV_VERSION >= 60100
   dvdnav_logger_cb loggerCallback;
-  loggerCallback.pf_log = dvd_logger;
+  loggerCallback.pf_log = CDVDCallback::dvd_logger;
 #endif
 
   // open up the DVD device
@@ -164,6 +168,19 @@ bool CDVDInputStreamNavigator::Open()
     }
   }
 #if DVDNAV_VERSION >= 60100
+  else if (URIUtils::IsNetworkFilesystem(path))
+  {
+    kodiDvdFilesystem.dir_open = CDVDCallback::dir_open;
+    kodiDvdFilesystem.file_open = CDVDCallback::file_open;
+    kodiDvdFilesystem.stat = CDVDCallback::stat;
+    kodiDvdFilesystem.close = CDVDCallback::close;
+    if (dvdnav_open_vfs_files(&m_dvdnav, nullptr, &loggerCallback, path.c_str(), &kodiDvdFilesystem) != DVDNAV_STATUS_OK)
+    {
+      CLog::Log(LOGERROR, "Error on dvdnav_open_vfs_files");
+      Close();
+      return false;
+    }
+  }
   else if (dvdnav_open2(&m_dvdnav, nullptr, &loggerCallback, path.c_str()) !=
            DVDNAV_STATUS_OK)
 #else
@@ -1520,30 +1537,6 @@ int dvd_inputstreamnavigator_cb_read(void * p_stream, void * buffer, int i_read)
   return i_ret;
 }
 
-void dvd_logger(void* priv, dvdnav_logger_level_t level, const char* fmt, va_list va)
-{
-  const std::string message = StringUtils::FormatV(fmt, va);
-  auto logLevel = LOGDEBUG;
-  switch (level)
-  {
-    case DVDNAV_LOGGER_LEVEL_INFO:
-      logLevel = LOGINFO;
-      break;
-    case DVDNAV_LOGGER_LEVEL_ERROR:
-      logLevel = LOGERROR;
-      break;
-    case DVDNAV_LOGGER_LEVEL_WARN:
-      logLevel = LOGWARNING;
-      break;
-    case DVDNAV_LOGGER_LEVEL_DEBUG:
-      logLevel = LOGDEBUG;
-      break;
-    default:
-      break;
-  };
-  CLog::Log(logLevel, "Libdvd: {}", message);
-}
-
 int dvd_inputstreamnavigator_cb_readv(void * p_stream, void * p_iovec, int i_blocks)
 {
   // NOTE/TODO: this vectored read callback somehow doesn't seem to be called by libdvdnav.
diff --git a/xbmc/filesystem/CMakeLists.txt b/xbmc/filesystem/CMakeLists.txt
index 8d2336a347..cae3c0d4c0 100644
--- a/xbmc/filesystem/CMakeLists.txt
+++ b/xbmc/filesystem/CMakeLists.txt
@@ -11,6 +11,7 @@ set(SOURCES AddonsDirectory.cpp
             DirectoryFactory.cpp
             DirectoryHistory.cpp
             DllLibCurl.cpp
+            DvdCallback.cpp
             EventsDirectory.cpp
             FavouritesDirectory.cpp
             FileCache.cpp
@@ -73,6 +74,7 @@ set(HEADERS AddonsDirectory.h
             DirectoryFactory.h
             DirectoryHistory.h
             DllLibCurl.h
+            DvdCallback.h
             EventsDirectory.h
             FTPDirectory.h
             FTPParse.h
diff --git a/xbmc/filesystem/DvdCallback.cpp b/xbmc/filesystem/DvdCallback.cpp
new file mode 100644
index 0000000000..2f247fff1f
--- /dev/null
+++ b/xbmc/filesystem/DvdCallback.cpp
@@ -0,0 +1,150 @@
+/*
+ *  Copyright (C) 2005-2018 Team Kodi
+ *  This file is part of Kodi - https://kodi.tv
+ *
+ *  SPDX-License-Identifier: GPL-2.0-or-later
+ *  See LICENSES/README.md for more information.
+ */
+
+#include "DvdCallback.h"
+
+#include "FileItem.h"
+#include "filesystem/Directory.h"
+#include "filesystem/File.h"
+#include "utils/StringUtils.h"
+#include "utils/URIUtils.h"
+#include "utils/log.h"
+
+using namespace XFILE;
+
+struct SDirState
+{
+  CFileItemList list;
+  int curr = 0;
+};
+
+void CDVDCallback::dvd_logger(void* priv, dvdnav_logger_level_t level, const char* fmt, va_list va)
+{
+  const std::string message = StringUtils::FormatV(fmt, va);
+  auto logLevel = LOGDEBUG;
+  switch (level)
+  {
+    case DVDNAV_LOGGER_LEVEL_INFO:
+      logLevel = LOGINFO;
+      break;
+    case DVDNAV_LOGGER_LEVEL_ERROR:
+      logLevel = LOGERROR;
+      break;
+    case DVDNAV_LOGGER_LEVEL_WARN:
+      logLevel = LOGWARNING;
+      break;
+    case DVDNAV_LOGGER_LEVEL_DEBUG:
+      logLevel = LOGDEBUG;
+      break;
+    default:
+      break;
+  };
+  CLog::Log(logLevel, "Libdvd: {}", message);
+}
+
+void CDVDCallback::dir_close(dvd_dir_h *dir)
+{
+  if (dir)
+  {
+    CLog::Log(LOGDEBUG, "CDVDCallback - Closed dir ({})", fmt::ptr(dir));
+    delete static_cast<SDirState*>(dir->internal);
+    delete dir;
+  }
+}
+
+dvd_dir_h* CDVDCallback::dir_open(const char* strDirname)
+{
+  CLog::Log(LOGDEBUG, "CDVDCallback - Opening dir {}", CURL::GetRedacted(strDirname));
+
+  SDirState *st = new SDirState();
+  if (!CDirectory::GetDirectory(strDirname, st->list, "", DIR_FLAG_DEFAULTS))
+  {
+    if (!CFile::Exists(strDirname))
+      CLog::Log(LOGDEBUG, "CDVDCallback - Error opening dir! ({})",
+                CURL::GetRedacted(strDirname));
+    delete st;
+    return nullptr;
+  }
+
+  dvd_dir_h* dir = new dvd_dir_h;
+  dir->close = dir_close;
+  dir->read = dir_read;
+  dir->internal = (void*)st;
+
+  return dir;
+}
+
+int CDVDCallback::dir_read(dvd_dir_h *dir, dvd_dirent_t *entry)
+{
+  SDirState* state = static_cast<SDirState*>(dir->internal);
+
+  if (state->curr >= state->list.Size())
+    return 1;
+
+  strncpy(entry->d_name, state->list[state->curr]->GetLabel().c_str(), sizeof(entry->d_name));
+  entry->d_name[sizeof(entry->d_name) - 1] = 0;
+  state->curr++;
+
+  return 0;
+}
+
+int64_t CDVDCallback::file_close(dvd_file_h *file)
+{
+  if (file)
+  {
+    delete static_cast<CFile*>(file->internal);
+    delete file;
+  }
+  return 0;
+}
+
+dvd_file_h * CDVDCallback::file_open(const char *filename, const char *cmode)
+{
+  dvd_file_h* file = new dvd_file_h;
+
+  file->close = file_close;
+  file->seek = file_seek;
+  file->read = file_read;
+
+  CFile* fp = new CFile();
+  if (fp->Open(filename))
+  {
+    file->internal = (void*)fp;
+    return file;
+  }
+
+  CLog::Log(LOGDEBUG, "CDVDCallback - Error opening file! ({})", CURL::GetRedacted(filename));
+
+  delete fp;
+  delete file;
+
+  return nullptr;
+}
+
+int64_t CDVDCallback::file_seek(dvd_file_h *file, int64_t offset, int32_t origin)
+{
+  return static_cast<CFile*>(file->internal)->Seek(offset, origin);
+}
+
+int64_t CDVDCallback::file_read(dvd_file_h *file, char *buf, int64_t size)
+{
+  return static_cast<int64_t>(static_cast<CFile*>(file->internal)->Read(buf, static_cast<size_t>(size)));
+}
+
+
+  int CDVDCallback::stat(const char *path, dvdstat_t* statbuff)
+  {
+    struct __stat64 tStat;
+    int result = CFile::Stat(path, &tStat);
+    statbuff->size = tStat.st_size;
+    statbuff->is_blk = S_ISBLK(tStat.st_mode);
+    statbuff->is_chr = S_ISCHR(tStat.st_mode);
+    statbuff->is_dir = S_ISDIR(tStat.st_mode);
+    statbuff->is_reg = S_ISREG(tStat.st_mode);
+    return result;
+  }
diff --git a/xbmc/filesystem/DvdCallback.h b/xbmc/filesystem/DvdCallback.h
new file mode 100644
index 0000000000..673108ec66
--- /dev/null
+++ b/xbmc/filesystem/DvdCallback.h
@@ -0,0 +1,47 @@
+/*
+ *  Copyright (C) 2005-2018 Team Kodi
+ *  This file is part of Kodi - https://kodi.tv
+ *
+ *  SPDX-License-Identifier: GPL-2.0-or-later
+ *  See LICENSES/README.md for more information.
+ */
+
+#pragma once
+
+#ifdef __cplusplus
+extern "C"
+{
+#endif
+#include <dvdread/dvd_filesystem.h>
+#include <dvdnav/dvdnav.h>
+#ifdef __cplusplus
+}
+#endif
+
+class CDVDCallback
+{
+public:
+  // logger implementation
+  static void dvd_logger(void* priv, dvdnav_logger_level_t level, const char* fmt, va_list va);
+
+  // filesystem close
+  static void close(void *) {};
+
+  // dir
+  static void dir_close(dvd_dir_h* dir);
+  static dvd_dir_h* dir_open(const char* strDirname);
+  static int dir_read(dvd_dir_h* dir, dvd_dirent_t* entry);
+
+  // file
+  static dvd_file_h* file_open(const char* filename, const char *cmode);
+  static int64_t file_close(dvd_file_h* file);
+  static int64_t file_read(dvd_file_h* file, char* buf, int64_t size);
+  static int64_t file_seek(dvd_file_h* file, int64_t offset, int32_t origin);
+
+  // stat
+  static int stat(const char *path, dvdstat_t* statbuf);
+
+private:
+  CDVDCallback() = default;
+  ~CDVDCallback() = default;
+};
\ No newline at end of file
-- 
2.43.0


From 7ff8f66715b60bd03beb9d88ea18625c6ffb45ea Mon Sep 17 00:00:00 2001
From: enen92 <92enen@gmail.com>
Date: Fri, 29 Jul 2022 14:05:57 +0100
Subject: [PATCH 4/9] Updates

---
 xbmc/DllPaths.h                                               | 2 +-
 .../VideoPlayer/DVDInputStreams/DVDInputStreamNavigator.cpp   | 4 ++--
 2 files changed, 3 insertions(+), 3 deletions(-)

diff --git a/xbmc/DllPaths.h b/xbmc/DllPaths.h
index 33fb46635e..9f8979355b 100644
--- a/xbmc/DllPaths.h
+++ b/xbmc/DllPaths.h
@@ -10,7 +10,7 @@
 
 #if defined (TARGET_ANDROID)
 #include "DllPaths_generated_android.h"
-#else
+#elif !defined (TARGET_WINDOWS)
 #include "DllPaths_generated.h"
 #endif
 
diff --git a/xbmc/cores/VideoPlayer/DVDInputStreams/DVDInputStreamNavigator.cpp b/xbmc/cores/VideoPlayer/DVDInputStreams/DVDInputStreamNavigator.cpp
index 46e4f79fa7..0535ae326f 100644
--- a/xbmc/cores/VideoPlayer/DVDInputStreams/DVDInputStreamNavigator.cpp
+++ b/xbmc/cores/VideoPlayer/DVDInputStreams/DVDInputStreamNavigator.cpp
@@ -174,9 +174,9 @@ bool CDVDInputStreamNavigator::Open()
     kodiDvdFilesystem.file_open = CDVDCallback::file_open;
     kodiDvdFilesystem.stat = CDVDCallback::stat;
     kodiDvdFilesystem.close = CDVDCallback::close;
-    if (dvdnav_open_vfs_files(&m_dvdnav, nullptr, &loggerCallback, path.c_str(), &kodiDvdFilesystem) != DVDNAV_STATUS_OK)
+    if (dvdnav_open_files(&m_dvdnav, nullptr, &loggerCallback, path.c_str(), &kodiDvdFilesystem) != DVDNAV_STATUS_OK)
     {
-      CLog::Log(LOGERROR, "Error on dvdnav_open_vfs_files");
+      CLog::Log(LOGERROR, "Error on dvdnav_open_files");
       Close();
       return false;
     }
-- 
2.43.0


From 0ced1b4df8b43474a75c75799bfa46611b79861d Mon Sep 17 00:00:00 2001
From: enen92 <92enen@gmail.com>
Date: Fri, 29 Jul 2022 14:41:39 +0100
Subject: [PATCH 5/9] update dvdnav version

---
 tools/depends/target/libdvdnav/LIBDVDNAV-VERSION | 7 +++----
 1 file changed, 3 insertions(+), 4 deletions(-)

diff --git a/tools/depends/target/libdvdnav/LIBDVDNAV-VERSION b/tools/depends/target/libdvdnav/LIBDVDNAV-VERSION
index eff7e7812b..f5541697ac 100644
--- a/tools/depends/target/libdvdnav/LIBDVDNAV-VERSION
+++ b/tools/depends/target/libdvdnav/LIBDVDNAV-VERSION
@@ -1,8 +1,7 @@
 LIBNAME=libdvdnav
-BASE_URL=https://github.com/xbmc/libdvdnav
-VERSION=6.1.1-Next-Nexus-Alpha2-2
-FULL_URL=$(BASE_URL)/archive/$(VERSION).tar.gz
+BASE_URL=https://github.com/enen92/libdvdnav
+VERSION=upstream_submission_kodi
 ARCHIVE=$(LIBNAME)-$(VERSION).tar.gz
-SHA512=51e6fc033121241354a5f0b3fc9a430577ae3ff6bb7f31445aa548ef4893037fb80eea3b2c6774c81e9ebaf9c45e9b490c98c2c65eb38f9f7daba84b236f7e1d
+SHA512=fca8c19a6787bb7a88a6a5e35f6a524505b607861b3bb391e3eca1e91b67d05b12417153542b161da0f13c4f5152f1d4860a34a6d230155c9c8c767fb35725b2
 BYPRODUCT=libdvdnav.a
 BYPRODUCT_WIN=libdvdnav.lib
-- 
2.43.0


From acffa5f3eb1a308a8a93acc17fca138913b624b0 Mon Sep 17 00:00:00 2001
From: enen92 <92enen@gmail.com>
Date: Fri, 29 Jul 2022 15:13:55 +0100
Subject: [PATCH 6/9] update versions

---
 tools/depends/target/libdvdread/LIBDVDREAD-VERSION | 7 +++----
 1 file changed, 3 insertions(+), 4 deletions(-)

diff --git a/tools/depends/target/libdvdread/LIBDVDREAD-VERSION b/tools/depends/target/libdvdread/LIBDVDREAD-VERSION
index d413ef4df2..74428acf49 100644
--- a/tools/depends/target/libdvdread/LIBDVDREAD-VERSION
+++ b/tools/depends/target/libdvdread/LIBDVDREAD-VERSION
@@ -1,8 +1,7 @@
 LIBNAME=libdvdread
-BASE_URL=https://github.com/xbmc/libdvdread
-VERSION=6.1.3-Next-Nexus-Alpha2-2
-FULL_URL=$(BASE_URL)/archive/$(VERSION).tar.gz
+BASE_URL=https://github.com/enen92/libdvdread
+VERSION=upstream_submission_kodi
 ARCHIVE=$(LIBNAME)-$(VERSION).tar.gz
-SHA512=629a41157d07b8ec0ea1fe89ae5ec48f63047472a862782b805c531ae31a0376fc4dc15175f8280c3ef91d7fa977bacebb1b51232640034a34bab2293210fc5e
+SHA512=d2fb890ccca8b8e7834470922f0b010f70b4016e829d71f51d3aaf30e2517ab7d98b46448313dd9c63141a71e794a8e679db4c1e0905e887c4897f7a5c194dc0
 BYPRODUCT=libdvdread.a
 BYPRODUCT_WIN=dvdread.lib
-- 
2.43.0


From af22856fc8ea2c6173631869f1d76ff8725193e2 Mon Sep 17 00:00:00 2001
From: enen92 <92enen@gmail.com>
Date: Fri, 29 Jul 2022 15:39:43 +0100
Subject: [PATCH 7/9] fixup

---
 tools/depends/target/libdvdread/LIBDVDREAD-VERSION            | 4 ++--
 .../VideoPlayer/DVDInputStreams/DVDInputStreamNavigator.cpp   | 2 +-
 2 files changed, 3 insertions(+), 3 deletions(-)

diff --git a/tools/depends/target/libdvdread/LIBDVDREAD-VERSION b/tools/depends/target/libdvdread/LIBDVDREAD-VERSION
index 74428acf49..38b7a10d8b 100644
--- a/tools/depends/target/libdvdread/LIBDVDREAD-VERSION
+++ b/tools/depends/target/libdvdread/LIBDVDREAD-VERSION
@@ -1,7 +1,7 @@
 LIBNAME=libdvdread
 BASE_URL=https://github.com/enen92/libdvdread
-VERSION=upstream_submission_kodi
+VERSION=upstream_skodi7
 ARCHIVE=$(LIBNAME)-$(VERSION).tar.gz
-SHA512=d2fb890ccca8b8e7834470922f0b010f70b4016e829d71f51d3aaf30e2517ab7d98b46448313dd9c63141a71e794a8e679db4c1e0905e887c4897f7a5c194dc0
+SHA512=932e83a9aeb949265538d935aab4689b9e8d8fe0611faad8ab066c97a418ad2dd907e65655b299950b296d7ff51394b89f51d41609cbfabb7db3d9201711e370
 BYPRODUCT=libdvdread.a
 BYPRODUCT_WIN=dvdread.lib
diff --git a/xbmc/cores/VideoPlayer/DVDInputStreams/DVDInputStreamNavigator.cpp b/xbmc/cores/VideoPlayer/DVDInputStreams/DVDInputStreamNavigator.cpp
index 0535ae326f..bf7b29619c 100644
--- a/xbmc/cores/VideoPlayer/DVDInputStreams/DVDInputStreamNavigator.cpp
+++ b/xbmc/cores/VideoPlayer/DVDInputStreams/DVDInputStreamNavigator.cpp
@@ -36,7 +36,7 @@
 
 #include <memory>
 
-#include <sys/uio.h>
+//#include <sys/uio.h>
 
 namespace
 {
-- 
2.43.0


From 5e5aa5e339586d5522fc91a7983ba08a00ee4bf0 Mon Sep 17 00:00:00 2001
From: enen92 <92enen@gmail.com>
Date: Fri, 29 Jul 2022 21:16:11 +0100
Subject: [PATCH 8/9] update libs for win

---
 .../depends/target/libdvdnav/LIBDVDNAV-VERSION  |  6 +++---
 .../target/libdvdread/LIBDVDREAD-VERSION        |  4 ++--
 .../DVDInputStreams/DVDInputStreamNavigator.cpp | 17 ++++++++++++++++-
 xbmc/filesystem/DvdCallback.cpp                 |  6 ++++++
 4 files changed, 27 insertions(+), 6 deletions(-)

diff --git a/tools/depends/target/libdvdnav/LIBDVDNAV-VERSION b/tools/depends/target/libdvdnav/LIBDVDNAV-VERSION
index f5541697ac..2f6110e0b6 100644
--- a/tools/depends/target/libdvdnav/LIBDVDNAV-VERSION
+++ b/tools/depends/target/libdvdnav/LIBDVDNAV-VERSION
@@ -1,7 +1,7 @@
 LIBNAME=libdvdnav
 BASE_URL=https://github.com/enen92/libdvdnav
-VERSION=upstream_submission_kodi
+VERSION=upstream_submission_kodi2
 ARCHIVE=$(LIBNAME)-$(VERSION).tar.gz
-SHA512=fca8c19a6787bb7a88a6a5e35f6a524505b607861b3bb391e3eca1e91b67d05b12417153542b161da0f13c4f5152f1d4860a34a6d230155c9c8c767fb35725b2
+SHA512=36bfedfd5628014164d757588e9165a7c4eb9f0dcd0c3fc393c7d6e1457d33f64f88a3a488c90d2862bfe65f99de274baa81c8e446ca9ad74d76d13166cebe24
 BYPRODUCT=libdvdnav.a
-BYPRODUCT_WIN=libdvdnav.lib
+BYPRODUCT_WIN=libdvdnav.lib
\ No newline at end of file
diff --git a/tools/depends/target/libdvdread/LIBDVDREAD-VERSION b/tools/depends/target/libdvdread/LIBDVDREAD-VERSION
index 38b7a10d8b..001f7572f6 100644
--- a/tools/depends/target/libdvdread/LIBDVDREAD-VERSION
+++ b/tools/depends/target/libdvdread/LIBDVDREAD-VERSION
@@ -1,7 +1,7 @@
 LIBNAME=libdvdread
 BASE_URL=https://github.com/enen92/libdvdread
-VERSION=upstream_skodi7
+VERSION=upstream_skodi8
 ARCHIVE=$(LIBNAME)-$(VERSION).tar.gz
-SHA512=932e83a9aeb949265538d935aab4689b9e8d8fe0611faad8ab066c97a418ad2dd907e65655b299950b296d7ff51394b89f51d41609cbfabb7db3d9201711e370
+SHA512=7946172ce3eeba869017038eaa215d915dff96550bc9b20d400fbe218ffe2622afb8de47df804ab165763330e4c818092c8d687ebc45422969062e0367c9fb6f
 BYPRODUCT=libdvdread.a
 BYPRODUCT_WIN=dvdread.lib
diff --git a/xbmc/cores/VideoPlayer/DVDInputStreams/DVDInputStreamNavigator.cpp b/xbmc/cores/VideoPlayer/DVDInputStreams/DVDInputStreamNavigator.cpp
index bf7b29619c..c5979ac0e7 100644
--- a/xbmc/cores/VideoPlayer/DVDInputStreams/DVDInputStreamNavigator.cpp
+++ b/xbmc/cores/VideoPlayer/DVDInputStreams/DVDInputStreamNavigator.cpp
@@ -36,7 +36,22 @@
 
 #include <memory>
 
-//#include <sys/uio.h>
+//FIXME
+#ifdef TARGET_WINDOWS
+#include "platform/win32/dirent.h"
+#else
+#include <dirent.h>
+#endif
+
+#ifdef TARGET_WINDOWS
+struct iovec
+{
+  void* iov_base; /* Pointer to data. */
+  size_t iov_len; /* Length of data.  */
+};
+#else
+#include <sys/uio.h> /* struct iovec */
+#endif
 
 namespace
 {
diff --git a/xbmc/filesystem/DvdCallback.cpp b/xbmc/filesystem/DvdCallback.cpp
index 2f247fff1f..a3bb72e808 100644
--- a/xbmc/filesystem/DvdCallback.cpp
+++ b/xbmc/filesystem/DvdCallback.cpp
@@ -17,6 +17,12 @@
 
 using namespace XFILE;
 
+#ifdef TARGET_WINDOWS
+#include "platform/win32/dirent.h"
+#else
+#include <dirent.h>
+#endif
+
 struct SDirState
 {
   CFileItemList list;
-- 
2.43.0


From 2cf6f1c799a586829bc5cac15efaf4bd61207324 Mon Sep 17 00:00:00 2001
From: enen92 <92enen@gmail.com>
Date: Tue, 9 Aug 2022 11:03:01 +0100
Subject: [PATCH 9/9] Backup new version

---
 .../DVDInputStreams/DVDInputStreamNavigator.cpp |  2 +-
 xbmc/filesystem/DvdCallback.cpp                 | 17 +++++++----------
 xbmc/filesystem/DvdCallback.h                   | 12 ++++++------
 3 files changed, 14 insertions(+), 17 deletions(-)

diff --git a/xbmc/cores/VideoPlayer/DVDInputStreams/DVDInputStreamNavigator.cpp b/xbmc/cores/VideoPlayer/DVDInputStreams/DVDInputStreamNavigator.cpp
index c5979ac0e7..e303b460da 100644
--- a/xbmc/cores/VideoPlayer/DVDInputStreams/DVDInputStreamNavigator.cpp
+++ b/xbmc/cores/VideoPlayer/DVDInputStreams/DVDInputStreamNavigator.cpp
@@ -92,7 +92,7 @@ static int dvd_inputstreamnavigator_cb_seek(void * p_stream, uint64_t i_pos);
 static int dvd_inputstreamnavigator_cb_read(void * p_stream, void * buffer, int i_read);
 static int dvd_inputstreamnavigator_cb_readv(void * p_stream, void * p_iovec, int i_blocks);
 
-static dvdnav_filesystem kodiDvdFilesystem;
+static dvdnav_filesystem_h kodiDvdFilesystem;
 
 CDVDInputStreamNavigator::CDVDInputStreamNavigator(IVideoPlayer* player, const CFileItem& fileitem)
   : CDVDInputStream(DVDSTREAM_TYPE_DVD, fileitem), m_pstream(nullptr)
diff --git a/xbmc/filesystem/DvdCallback.cpp b/xbmc/filesystem/DvdCallback.cpp
index a3bb72e808..16b359b27e 100644
--- a/xbmc/filesystem/DvdCallback.cpp
+++ b/xbmc/filesystem/DvdCallback.cpp
@@ -63,7 +63,7 @@ void CDVDCallback::dir_close(dvd_dir_h *dir)
   }
 }
 
-dvd_dir_h* CDVDCallback::dir_open(const char* strDirname)
+dvd_dir_h* CDVDCallback::dir_open(dvdnav_filesystem_h *fs, const char* strDirname)
 {
   CLog::Log(LOGDEBUG, "CDVDCallback - Opening dir {}", CURL::GetRedacted(strDirname));
 
@@ -99,7 +99,7 @@ int CDVDCallback::dir_read(dvd_dir_h *dir, dvd_dirent_t *entry)
   return 0;
 }
 
-int64_t CDVDCallback::file_close(dvd_file_h *file)
+int CDVDCallback::file_close(dvd_file_h *file)
 {
   if (file)
   {
@@ -109,7 +109,7 @@ int64_t CDVDCallback::file_close(dvd_file_h *file)
   return 0;
 }
 
-dvd_file_h * CDVDCallback::file_open(const char *filename, const char *cmode)
+dvd_file_h * CDVDCallback::file_open(dvdnav_filesystem_h *fs, const char *filename)
 {
   dvd_file_h* file = new dvd_file_h;
 
@@ -137,20 +137,17 @@ int64_t CDVDCallback::file_seek(dvd_file_h *file, int64_t offset, int32_t origin
   return static_cast<CFile*>(file->internal)->Seek(offset, origin);
 }
 
-int64_t CDVDCallback::file_read(dvd_file_h *file, char *buf, int64_t size)
+ssize_t CDVDCallback::file_read(dvd_file_h *file, char *buf, size_t size)
 {
-  return static_cast<int64_t>(static_cast<CFile*>(file->internal)->Read(buf, static_cast<size_t>(size)));
+  return static_cast<ssize_t>(static_cast<CFile*>(file->internal)->Read(buf, size));
 }
 
 
-  int CDVDCallback::stat(const char *path, dvdstat_t* statbuff)
+  int CDVDCallback::stat(dvdnav_filesystem_h *fs, const char *path, dvdstat_t* statbuff)
   {
     struct __stat64 tStat;
     int result = CFile::Stat(path, &tStat);
     statbuff->size = tStat.st_size;
-    statbuff->is_blk = S_ISBLK(tStat.st_mode);
-    statbuff->is_chr = S_ISCHR(tStat.st_mode);
-    statbuff->is_dir = S_ISDIR(tStat.st_mode);
-    statbuff->is_reg = S_ISREG(tStat.st_mode);
+    statbuff->st_mode = tStat.st_mode;
     return result;
   }
diff --git a/xbmc/filesystem/DvdCallback.h b/xbmc/filesystem/DvdCallback.h
index 673108ec66..8451372422 100644
--- a/xbmc/filesystem/DvdCallback.h
+++ b/xbmc/filesystem/DvdCallback.h
@@ -25,21 +25,21 @@ public:
   static void dvd_logger(void* priv, dvdnav_logger_level_t level, const char* fmt, va_list va);
 
   // filesystem close
-  static void close(void *) {};
+  static void close(dvdnav_filesystem_h *fs) {};
 
   // dir
   static void dir_close(dvd_dir_h* dir);
-  static dvd_dir_h* dir_open(const char* strDirname);
+  static dvd_dir_h* dir_open(dvdnav_filesystem_h *fs, const char* strDirname);
   static int dir_read(dvd_dir_h* dir, dvd_dirent_t* entry);
 
   // file
-  static dvd_file_h* file_open(const char* filename, const char *cmode);
-  static int64_t file_close(dvd_file_h* file);
-  static int64_t file_read(dvd_file_h* file, char* buf, int64_t size);
+  static dvd_file_h* file_open(dvdnav_filesystem_h *fs, const char* filename);
+  static int file_close(dvd_file_h* file);
+  static ssize_t file_read(dvd_file_h* file, char* buf, size_t size);
   static int64_t file_seek(dvd_file_h* file, int64_t offset, int32_t origin);
 
   // stat
-  static int stat(const char *path, dvdstat_t* statbuf);
+  static int stat(dvdnav_filesystem_h *fs, const char *path, dvdstat_t* statbuf);
 
 private:
   CDVDCallback() = default;
-- 
2.43.0

